# Locate NLopt Library
# this modules defines
#  NLOPT_FOUND
#  NLOPT_INCLUDE_DIR
#  NLOPT_LIBRARIES
#  NLOPT_LIBS

find_library(NLOPT_LIBRARIES
    NAMES nlopt nlopt_cxx libnlopt-0
    HINTS ENV LD_LIBRARY_PATH 
    PATH_SUFFIXES lib64 lib
    PATHS
    /usr/local
    /usr
)

if(NLOPT_LIBRARIES)
    string(REGEX REPLACE "(.*)/lib[^ /]*/libnlopt.so" 
                         "\\1" 
                         NLOPT_LIBS 
                         "${NLOPT_LIBRARIES}")
endif(NLOPT_LIBRARIES)

find_path(NLOPT_INCLUDE_DIR nlopt.h
    PATH_SUFFIXES include
    PATHS
    ${NLOPT_LIBS}
    /usr/local
    /usr
)


#INCLUDE(${CMAKE_CURRENT_LIST_DIR}/FindPackageHandleStandardArgs.cmake)
find_package_handle_standard_args(NLOPT DEFAULT_MSG NLOPT_LIBRARIES NLOPT_INCLUDE_DIR)
mark_as_advanced(NLOPT_INCLUDE_DIRS NLOPT_LIBRARIES)

