# - Find OPT++ installation
# This module tries to find the OPT++ installation on your system.
# If the system variable OPTSYS is set this is straight forward.
# If not the module uses the pathes given in OPT_CONFIG_SEARCHPATH.
# If you need an other path you should add this path to this variable.  



MESSAGE(STATUS "Looking for Opt++...")
SET(OPT_LIB)
SET(OPT_INCLUDE_DIR)
SET(OPT_LIBRARY)

if(WIN32)
	SET(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
endif(WIN32)

FIND_LIBRARY(OPT_LIB NAMES opt libopt PATHS 
					ENV LD_LIBRARY_PATH 
					ENV PATH 
					${OPTPP_LIB_DIR}
					NO_DEFAULT_PATH)
FIND_LIBRARY(OPT_LIB_newmat NAMES newmat libnewmat PATHS 
					ENV LD_LIBRARY_PATH 
					ENV PATH 
					${OPTPP_LIB_DIR}					
					NO_DEFAULT_PATH)

IF(OPT_LIB)
    #Determines OPT version
	if(UNIX)
      STRING(REGEX REPLACE "(.*)/lib[64]*/libopt.so" "\\1" OPT_LIBRARY "${OPT_LIB}")
    else(UNIX)
      STRING(REGEX REPLACE "(.*)/lib[64]*/libopt.lib" "\\1" OPT_LIBRARY "${OPT_LIB}")
    endif(UNIX)

    SET(OPT_INCLUDE_DIR ${OPT_LIBRARY}/include)
    SET(OPT_LIBRARY ${OPT_LIBRARY}/lib)
	
    SET(OPT_FOUND TRUE)
    MESSAGE(STATUS "Looking for Opt++... - Found")
ELSE(OPT_LIB)
    MESSAGE(STATUS "Looking for Opt++... -  Unset! Please ensure that paths are correctly defined.")
ENDIF(OPT_LIB)
