# Locate pthread-win32 Library
# this modules defines
#  PTHREAD_FOUND
#  PTHREAD_INCLUDE_DIR
#  PTHREAD_LIBRARY
#  PTHREAD_LIBRARIES

# if(WIN32) 
SET(CMAKE_FIND_LIBRARY_SUFFIXES ".dll")
FIND_LIBRARY(PTHREAD_DLL_LIBRARY
    NAMES pthreadVCE3
    HINTS  ENV PATH
    PATH_SUFFIXES lib64 lib debug release
)

SET(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
if(EXISTS ${PTHREAD_DLL_LIBRARY})
    get_filename_component(PTHREAD_PATH ${PTHREAD_DLL_LIBRARY} PATH)
	string(REGEX REPLACE "dll/x86" "" PTHREAD_PATH ${PTHREAD_PATH})
    FIND_LIBRARY(PTHREAD_LIBRARY
    NAMES pthreadVCE3
    PATH_SUFFIXES lib64 lib lib/x86 debug release
	PATHS ${PTHREAD_PATH}
    )
	get_filename_component(PTHREAD_LIBRARY ${PTHREAD_LIBRARY} PATH)
	
	FIND_PATH(PTHREAD_INCLUDE_DIR pthread.h
    PATH_SUFFIXES include
    PATHS ${PTHREAD_PATH}
    )
    set(PTHREAD_LIBRARIES ${PTHREAD_LIBRARY}/pthreadVCE3.lib)
endif(EXISTS ${PTHREAD_DLL_LIBRARY})

find_package_handle_standard_args(PTHREAD DEFAULT_MSG PTHREAD_DLL_LIBRARY PTHREAD_LIBRARY PTHREAD_INCLUDE_DIR)


# endif(WIN32)