# Find Uranie version
# This module tries to find the Uranie version to package
# It reads the file version_number in the sub-directory adm which gives Uranie version.
# If the file version_number gives a NULL version,  it returns date of packaging

MESSAGE(STATUS "Looking for Uranie...")

SET(VN_FILE VN_FILE-NOTFOUND)
string(TIMESTAMP DATE %Y.%m.%d)

FIND_FILE(VN_FILE version_number PATH ${URANIE_SOURCE_DIR}/adm)


IF(${VN_FILE} MATCHES "VN_FILE-NOTFOUND")
  MESSAGE(STATUS "------- WARNING : The file \"version_number\" is not found. The current date is selected.")
  SET(URANIE_VERSION ${DATE})
ELSE(${VN_FILE} MATCHES "VN_FILE-NOTFOUND")
  FILE(READ ${VN_FILE} ALL_STRING_VERSION_NUMBER)
  STRING(REPLACE " " "" tt1 "${ALL_STRING_VERSION_NUMBER}")
  STRING(REPLACE "$" "" tt2 "${tt1}")
  STRING(REPLACE "Name:" "" ttf "${tt2}")
  
  STRING(REGEX MATCH "v[0-9]*_[0-9]*_[0-9]*" isMatch "${ttf}")
  
  IF ( isMatch )
    STRING(REPLACE "v" "" STRING_VERSION_NUMBER "${isMatch}")
    STRING(REPLACE "_" "." URANIE_VERSION ${STRING_VERSION_NUMBER})
  ELSE ( isMatch )
    SET(URANIE_VERSION ${DATE})
  ENDIF ( isMatch )
  
ENDIF(${VN_FILE} MATCHES "VN_FILE-NOTFOUND")

MESSAGE(STATUS "Looking for Uranie... - version ${URANIE_VERSION} ")   
STRING(REGEX REPLACE "([0-9]+)\\.[0-9]+\\.[0-9]+" "\\1" URANIE_VERSION_MAJOR "${URANIE_VERSION}")
STRING(REGEX REPLACE "[0-9]+\\.([0-9]+)\\.[0-9]+" "\\1" URANIE_VERSION_MINOR "${URANIE_VERSION}")
STRING(REGEX REPLACE "[0-9]+\\.[0-9]+\\.([0-9]+)" "\\1" URANIE_VERSION_PATCH "${URANIE_VERSION}")

###### End of FindUranieVersion.cmake
