# - Find VIZIR installation
# This module tries to find the VIZIR installation on your system.
# If the system variable VIZIRSYS is set this is straight forward.
# If not the module uses the pathes given in VIZIR_CONFIG_SEARCHPATH.
# If you need an other path you should add this path to this variable.  



MESSAGE(STATUS "Looking for Vizir...")
SET(VIZIR_LIB)
SET(VIZIR_INCLUDE_DIR)
SET(VIZIR_LIBRARY)

FIND_LIBRARY(VIZIR_LIB NAMES vzrc PATHS ENV LD_LIBRARY_PATH NO_DEFAULT_PATH)

IF(VIZIR_LIB)
    #Determines VIZIR version
    STRING(REGEX REPLACE "(.*)/lib/libvzrc.so" "\\1" VIZIR_LIBRARY "${VIZIR_LIB}")
    SET( ENV{VIZIRSYS} ${VIZIR_LIBRARY})
    SET( VIZIRSYS ${VIZIR_LIBRARY})
    SET(VIZIR_INCLUDE_DIR ${VIZIR_LIBRARY}/include)
    SET(VIZIR_LIBRARY ${VIZIR_LIBRARY}/lib)
    SET(VIZIR_LIB_FOUND TRUE)
    MESSAGE(STATUS "Looking for Vizir... - Found")
ELSE(VIZIR_LIB)
    MESSAGE(STATUS "Looking for Vizir... -  Unset! Please ensure that paths are correctly defined.")
ENDIF(VIZIR_LIB)