#-------------------------------------------------------------------------
# JSONCPP installation through archive
#-------------------------------------------------------------------------

# The jsoncpp path dir
set(JSONCPP_DIR "jsoncpp-0.10.5")
FILE(TO_NATIVE_PATH "${CMAKE_BINARY_DIR}/JSONCPP/BUILD" JSONCPP_BUILD_DIR)
FILE(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/JSONCPP/${JSONCPP_DIR}" JSONCPP_INSTALL_DIR)

FILE(TO_NATIVE_PATH "${JSONCPP_INSTALL_DIR}/lib" JSONCPP_LIB_DIR)
FILE(TO_NATIVE_PATH "${JSONCPP_INSTALL_DIR}/bin" JSONCPP_BIN_DIR)

if(WIN32)
    set(7ZIP_EXEC "C:/Program Files/7-Zip/7z.exe")
endif(WIN32)

if(WITH-JSONCPP STREQUAL "ON")
    message(STATUS "Untar JSONCPP archive")
    exec_program(${CMAKE_COMMAND} ARGS -E  make_directory ${JSONCPP_BUILD_DIR} OUTPUT_VARIABLE BLA)
    exec_program(${CMAKE_COMMAND} ARGS -E  make_directory ${JSONCPP_INSTALL_DIR} OUTPUT_VARIABLE BLA)
    if(WIN32)	
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${CMAKE_SOURCE_DIR}/tools ${7ZIP_EXEC} x "${CMAKE_SOURCE_DIR}/tools/${JSONCPP_DIR}.tar.gz" -o${JSONCPP_BUILD_DIR} -y OUTPUT_VARIABLE BLA)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${CMAKE_SOURCE_DIR}/tools ${7ZIP_EXEC} x "${JSONCPP_BUILD_DIR}/${JSONCPP_DIR}.tar" -o${JSONCPP_BUILD_DIR} -y OUTPUT_VARIABLE BLA)
    else(WIN32)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${CMAKE_SOURCE_DIR}/tools tar zxf "${CMAKE_SOURCE_DIR}/tools/${JSONCPP_DIR}.tar.gz" -C ${JSONCPP_BUILD_DIR} OUTPUT_VARIABLE BLA)
    endif(WIN32)
    message(STATUS "** Configuring JSONCPP...")
    set(GENERATOR_OPTION)
    if(WIN32)
        set(GENERATOR_OPTION -A ${CMAKE_GENERATOR_PLATFORM})
    endif(WIN32)
    exec_program(${CMAKE_COMMAND} ARGS -E chdir "${JSONCPP_BUILD_DIR}/${JSONCPP_DIR}" cmake ${GENERATOR_OPTION} -DBUILD_SHARED_LIBS=ON -DBUILD_STATIC_LIBS=OFF -DCMAKE_INSTALL_PREFIX=${JSONCPP_INSTALL_DIR} "${JSONCPP_BUILD_DIR}/${JSONCPP_DIR}" OUTPUT_VARIABLE BLA)
    message(STATUS "**  Done")
    message(STATUS "** Compiling and installing JSONCPP")
    exec_program(${CMAKE_COMMAND} ARGS -E chdir "${JSONCPP_BUILD_DIR}/${JSONCPP_DIR}" cmake --build . --config Release --target install OUTPUT_VARIABLE BLA)
    message(STATUS "**  Done")
    
    #Sets environment variables
    set(ENV{C_INCLUDE_PATH} "${JSONCPP_INSTALL_DIR}/include:$ENV{C_INCLUDE_PATH}")
    if(WIN32)
        set(ENV{LD_LIBRARY_PATH} "${JSONCPP_LIB_DIR};$ENV{LD_LIBRARY_PATH}")
	set(ENV{LD_LIBRARY_PATH} "${JSONCPP_BIN_DIR};$ENV{LD_LIBRARY_PATH}")
    else(WIN32)
        set(ENV{LD_LIBRARY_PATH} "${JSONCPP_LIB_DIR}:$ENV{LD_LIBRARY_PATH}")
	set(ENV{LD_LIBRARY_PATH} "${JSONCPP_BIN_DIR}:$ENV{LD_LIBRARY_PATH}")
    endif(WIN32)
    
    
endif(WITH-JSONCPP STREQUAL "ON")
  
