#include<iostream>

#include <stdio.h>
#include <iostream.h>
#include<time.h>

int main(int argc, char *argv[])
{
    // Reads from the file version_number the new uranie version number
    // and generates the header ../UranieVersion.h.
    // To be executed as CINT script by build/unix/makeversion.sh.
    //
    // Author: Fons Rademakers   11/10/99

    const char *incvs = "version_number";
    const char *outh = "../dataSERVER/souRCE/UVersion.h";

    cout << " Read the uranie version from file[" << incvs << "]" << endl;
    cout << " and create the header file[" << outh << "]" << endl;

    //////////////////////////////////
    //// Open the input : version number
    //////////////////////////////////
    FILE *fp = fopen(incvs, "r");
    if (!fp)
    {
        printf("%s: can not open input file %s\n", argv[0], incvs);
        exit(1);
    }

    char vers[32];
    fgets(vers, sizeof(vers), fp);
    if (vers[strlen(vers) - 1] == '\n')
        vers[strlen(vers) - 1] = 0;
    fclose(fp);
    cout << "begin vers[" << vers << "]" << endl;
    int ncharvers = strlen(vers);

    //////////////////////////////////
    //// Create the output : header file
    //////////////////////////////////
    fp = fopen(outh, "w");
    if (!fp)
    {
        printf("%s: can not open output file %s\n", argv[0], outh);
        exit(1);
    }

    fprintf(fp, "#ifndef URANIE_UVersion\n");
    fprintf(fp, "#define URANIE_UVersion\n\n");
    fprintf(fp,
            "/* Version information automatically generated by installer. */\n\n");
    fprintf(fp, "/*\n");
    fprintf(fp, " * These macros can be used in the following way:\n");
    fprintf(fp, " *\n");
    fprintf(fp, " *    #if URANIE_VERSION_CODE >= URANIE_VERSION(0,4,1)\n");
    fprintf(fp, " *       #include <newheader.h>\n");
    fprintf(fp, " *    #else\n");
    fprintf(fp, " *       #include <oldheader.h>\n");
    fprintf(fp, " *    #endif\n");
    fprintf(fp, " *\n");
    fprintf(fp, "*/\n\n");

    int xx = 0, yy = 0, zz;
    if (ncharvers == 9)
    {
        time_t theNow;
        time(&theNow);
        tm *ff = gmtime(&theNow);
        xx = 1900 + ff->tm_year;
        yy = 1 + ff->tm_mon;
        zz = 1 + ff->tm_mday;
    }
    else
    {
        sscanf(vers, "$Name: v%d_%d_%d ", &xx, &yy, &zz);
    }

    cout << "Version v" << xx << "." << yy << "/" << zz << endl;
    int vers_code = (xx << 16) + (yy << 8) + zz;

    fprintf(fp, "#define URANIE_RELEASE \"%d.%d/%d\"\n", xx, yy, zz);
    fprintf(fp, "#define URANIE_RELEASE_MAJOR %d\n", xx);
    fprintf(fp, "#define URANIE_RELEASE_MINOR %d\n", yy);
    fprintf(fp, "#define URANIE_RELEASE_PATCH %d\n", zz);
    fprintf(fp, "#define URANIE_RELEASE_DATE \"%s\"\n", __DATE__);
    fprintf(fp, "#define URANIE_RELEASE_TIME \"%s\"\n", __TIME__);
    fprintf(fp, "#define URANIE_VERSION_CODE %d\n", vers_code);
    fprintf(fp,
            "#define URANIE_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))\n");
    fprintf(fp, "\n#endif\n");

    fclose(fp);

    exit(0);
}
