/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   UranieDataServerLinkDef.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2014-09-17
 
 \brief  DataServer exported classes
*/

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;

#pragma link C++ namespace URANIE::DataServer;

// ex Logger
#pragma link C++ class URANIE::DataServer::UMessageLogger;
#pragma link C++ class URANIE::DataServer::UTimer;

// ex DATASERVER
#pragma link C++ class URANIE::DataServer::TDataServer+;
#pragma link C++ class URANIE::DataServer::TDataSpecification+;
#pragma link C++ class URANIE::DataServer::TPatternsEventList+;
#pragma link C++ class URANIE::DataServer::TPermutation+;
#pragma link C++ struct URANIE::DataServer::TAttributeFileKey+;
#pragma link C++ class list<URANIE::DataServer::TAttributeFileKey*>+;
#pragma link C++ class list<URANIE::DataServer::TAttributeFileKey*>::iterator+;
#pragma link C++ class URANIE::DataServer::TAttribute+;
#pragma link C++ class URANIE::DataServer::TAttributeFormula+;
#pragma link C++ class URANIE::DataServer::TStochasticAttribute+;
#pragma link C++ class URANIE::DataServer::TInfiniteDistribution+;
#pragma link C++ class URANIE::DataServer::TNormalDistribution+;
#ifdef WITH_MATHMORE
#pragma link C++ class URANIE::DataServer::TStudentDistribution+;
#endif
#pragma link C++ class URANIE::DataServer::TGumbelMaxDistribution+;
#pragma link C++ class URANIE::DataServer::TLogNormalDistribution+;
#pragma link C++ class URANIE::DataServer::TUniformDistribution+;
#pragma link C++ class URANIE::DataServer::TLogUniformDistribution+;
#pragma link C++ class URANIE::DataServer::TTriangularDistribution+;
#pragma link C++ class URANIE::DataServer::TLogTriangularDistribution+;
#pragma link C++ class URANIE::DataServer::TExponentialDistribution+;
#pragma link C++ class URANIE::DataServer::TWeibullDistribution+;
#pragma link C++ class URANIE::DataServer::TGammaDistribution+;
#pragma link C++ class URANIE::DataServer::TInvGammaDistribution+;
#pragma link C++ class URANIE::DataServer::TGeneralizedNormalDistribution+;
#pragma link C++ class URANIE::DataServer::TGeneralizedNormalV2Distribution+;
#pragma link C++ class URANIE::DataServer::TBetaDistribution+;
#pragma link C++ class URANIE::DataServer::TCauchyDistribution+;
#pragma link C++ class URANIE::DataServer::TUniformByPartsDistribution+;
#pragma link C++ class URANIE::DataServer::TTrapeziumDistribution+;
#pragma link C++ class URANIE::DataServer::TDiscreteAttribute+;
//#pragma link C++ class URANIE::DataServer::TMultinomialDistribution+;
#pragma link C++ class URANIE::DataServer::TCustomDistribution+;
#pragma link C++ class URANIE::DataServer::TComposedDistribution+;
#pragma link C++ class URANIE::DataServer::TPossibilityAttribute+;
#pragma link C++ class URANIE::DataServer::TTriangularPossibility+;
#pragma link C++ class URANIE::DataServer::TTrapeziumPossibility+;
#pragma link C++ class URANIE::DataServer::TGenParetoDistribution+;
#pragma link C++ class URANIE::DataServer::TPCA+;
#pragma link C++ class URANIE::DataServer::TDSNtupleD+;
#pragma link C++ class URANIE::DataServer::UEntry+;

#pragma extra_include "vector";
#include <vector>
#pragma link C++ class std::vector<URANIE::DataServer::UEntry*>+;
#pragma link C++ class std::vector<URANIE::DataServer::UEntry*>::iterator+;

//#pragma link C++ class URANIE::DataServer::TTemporalTree+;

// ex XMLProblem
//#pragma link C++ class URANIE::DataServer::TXMLProblem+;

// ex Exceptions
#pragma link C++ namespace URANIE::Exceptions;

#pragma link C++ class URANIE::Exceptions::UExceptions+;
#pragma link C++ class URANIE::Exceptions::UWarningExceptions;
#pragma link C++ class URANIE::Exceptions::UDeprecatedExceptions;
#pragma link C++ class URANIE::Exceptions::UErrorExceptions;
#pragma link C++ class URANIE::Exceptions::UInfoExceptions;

