//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
/*!
 \file   TDiscreteAttribute.cxx
 \author 
 \date   $date$
 
 \brief  Implementation of the class URANIE::DataServer::TDiscreteAttribute
 
 */

#include <iostream>

#include "TDiscreteAttribute.h"

ClassImp (URANIE::DataServer::TDiscreteAttribute)

namespace URANIE
{
namespace DataServer
{
//! 
/*! 
 
 */

// -----------------------------------------------------------------------
//  Constructors
// -----------------------------------------------------------------------
TDiscreteAttribute::TDiscreteAttribute()
{
}

TDiscreteAttribute::TDiscreteAttribute(TString str) :
        TStochasticAttribute(str, TStochasticAttribute::kMultinomial)
{
}

TDiscreteAttribute::TDiscreteAttribute(TString str, ELawType value) :
        TStochasticAttribute(str, value)
{
}

TDiscreteAttribute::TDiscreteAttribute(TAttribute *object, ELawType value) :
        TStochasticAttribute(object, value)
{
    SetName(object->GetName());
    SetTitle(object->GetTitle());
    setUnity(object->getUnity());
    _snote = object->getNote();
    _nType = object->getDataType();
    _lawType = value;
    //dmean = 0.0;
    //dstddev = 1.0;
}

TDiscreteAttribute::~TDiscreteAttribute()
{

}

void TDiscreteAttribute::printLog()
{
    TStochasticAttribute::printLog();
    cout << "*******************************" << endl;
    cout << "** TDiscreteAttribute::printLog  ******" << endl;
    cout << "**   Name [" << GetName() << "]" << endl;
    cout << "**   label[" << GetTitle() << "]" << endl;
    cout << "**   unit [" << getUnity() << "]" << endl;
    cout << "**   law  [" << _lawType << "]" << endl;
    cout << "**   type [" << _nType << "]" << endl;
    cout << "*******************************" << endl;
}

} // Fin du namespace DataServer
} // Fin du namespace URANIE
