//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef TTOKENIZER_H_
#define TTOKENIZER_H_

#include <string>
#include <vector>

/**

 * @class TTokenizer

 * @brief Tokenizer class for parsing strings.

 */
class TTokenizer
{
    std::string quotes;
    std::string delimiters;
    int nQuotes, nDelims;
    char comment;

public:
//	TTokenizer(const char* = " ,\t", const char* = "\'\"", const int = -1);
    TTokenizer(const std::string& = " ,\t\n\r", const std::string& = "\'\"",
            const int = -1);

    std::vector<std::string> getTokens(const std::string&);

    void setDelimiters(const std::string&);
    void setQuotes(const std::string&);
    void setComment(char);

//private:
    bool isDelimiter(char);
    bool isQuote(char);
};

#endif
