//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTPatternsEventList.h
 \author C�dric Forgues (C.S.) <uranietm@cea.fr>
 \date   $Date$
 
 \brief  Fichier de test de la classe URANIE::DataServer::TPatternsEventList
 
 Cr�e le : mar avri 26 10:00:00 2010

 // *****************************************************************************

 */
#ifndef CPPUNITEST_TPATTERNSEVENTLIST_H
#define CPPUNITEST_TPATTERNSEVENTLIST_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

#include "TPatternsEventList.h"
#include "UExceptions.h"

/*! \class TPatternsEventListTest
 * \brief Unit tests for TPatternsEventList.
 */
class TPatternsEventListTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TPatternsEventListTest);
    CPPUNIT_TEST (testTPatternsEventListAttributes);
    CPPUNIT_TEST (testEnter);
    CPPUNIT_TEST (testMix);
    CPPUNIT_TEST (throwExceptionMix);CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TPatternsEventListTest object.
     */
    TPatternsEventListTest();

    /// Destructor.
    virtual ~TPatternsEventListTest();

    void setUp();
    void tearDown();

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    //! Tests the good behaviour of the constructor. 
    void testTPatternsEventListAttributes();

    //! Tests the good behaviour of the Enter() method.
    void testEnter();

    //! Tests the good behaviour of the Mix() method.
    void testMix();

    //! Throws an exception when the TPatternsEventList doesn't have an index input.
    void throwExceptionMix();

    //@}

private:
    URANIE::DataServer::TPatternsEventList * _tpe;
};
#endif  // CPPUNITEST_TPATTERNSEVENTLIST_H
