//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TIntMPI.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   mon oct 9th 10:38:34 CEST 2006
 
 \brief Interface of the class URANIE::Distribution::TIntMPI
 
 */
/**
 
 * @class URANIE::Launcher::TIntMPI
 *
 * @brief Description of the class TIntMPI.
 *
 * To be written by the developper.
 *
 */
#ifndef TINTMPI_H
#define TINTMPI_H

#include "TLauncher.h"

// MPI
#include "mpi.h"            // For some private variables

namespace URANIE
{
namespace Launcher
{
class TIntMPI
{
private:
public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TIntMPI();
    //! Default destructor
    virtual ~TIntMPI();
    //@}

    //@{ \name Initialization and exit
    static int init(int& argc, char**& argv);
    static void exit();
    //@}

    //@{ \name Status and notify

    //! Returns PVM taskid or MPI rank. 
    static int getMyTid();

    //! Returns the number of processes.
    static int getNumProcs();
    //@}

    //---------------------------------------------
    /** @name Printing Log
     **/
    //@{
    virtual void printLog(Option_t *option = "");
    //@}

    ClassDef(URANIE::Launcher::TIntMPI, ID_LAUNCHER)
    //Classe de
};

} // Fin du namespace Distribution
} // Fin du namespace URANIE
#endif
