//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_TAMPONTEXTE_H
#define CPPUNITEST_TAMPONTEXTE_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>


#ifndef OLDCLUB
#include "TamponTexte.h"
#else
#include "club/TamponTexte.h"
#endif

// Uranie
#include "UExceptions.h"
#include "TCode.h"

class TestTamponTexte: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TestTamponTexte);
    CPPUNIT_TEST (testWrongFile);
    CPPUNIT_TEST (testNombreLignes);
    CPPUNIT_TEST (testElimineBlancs);
    CPPUNIT_TEST (testElimineCommentaires);
    CPPUNIT_TEST (testChampLigne);
    CPPUNIT_TEST (testChamp);
    CPPUNIT_TEST (testNombreChampsLigne);
    CPPUNIT_TEST (testRemplaceChamp);
    CPPUNIT_TEST (testEcrit);
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TestTamponTexte();

    //! Default destructor
    virtual ~TestTamponTexte();

    void setUp();
    void tearDown();
	
    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    void testWrongFile();
    void testNombreLignes();
    void testElimineBlancs();
    void testElimineCommentaires();
    void testChampLigne();
    void testChamp();
    void testNombreChampsLigne();
    void testRemplaceChamp();
    void testEcrit();

private:
    TString _workingTestPath;

    Bool_t _bLog;
};

#endif  // CPPUNITEST_TAMPONTEXTE_H
