 
{ 
  // Create a TDataServer
  TDataServer * tds = new TDataServer();
  // Load the data base in the DataServer
  tds->fileDataRead("flowrateUniformDesign.dat");

  // The reference input file
  TString sIn = TString("flowrate_input_with_keys.in");
  
  // Set the reference input file and the key for each input attributes
  tds->getAttribute("rw")->setFileKey(sIn, "Rw");
  tds->getAttribute("r")->setFileKey(sIn, "R");
  tds->getAttribute("tu")->setFileKey(sIn, "Tu");
  tds->getAttribute("tl")->setFileKey(sIn, "Tl");
  tds->getAttribute("hu")->setFileKey(sIn, "Hu");
  tds->getAttribute("hl")->setFileKey(sIn, "Hl");
  tds->getAttribute("l")->setFileKey(sIn, "L");
  tds->getAttribute("kw")->setFileKey(sIn, "Kw");
  
  // The output file of the code
  TOutputFileRow *fout = new TOutputFileRow("_output_flowrate_withRow_.dat");
  // The attribute in the output file
  fout->addAttribute(new TAttribute("yhat"));
  
  // Instanciation de mon code
  TCode *mycode = new TCode(tds, "flowrate -s -k");
  // on ajoute le fichier de sortie du code
  mycode->addOutputFile( fout );
  
  // Lancement du code
  TLauncher *lanceur = new TLauncher(tds, mycode);
  lanceur->setSave();
  lanceur->setClean();
  //lanceur->setWorkingDirectory(gSystem->Getenv("PWD") + TString("/tmpLanceurUranie/flowrate"));
  lanceur->setVarDraw("yhat:rw","","");
  lanceur->run();
  

  // Graph
  TCanvas  *Canvas = new TCanvas("c1", "Graph for the Macro launchCodeFlowrateKeyDataBase",5,64,1270,667);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw();
  pad->Divide(2,4);
  
  pad->cd(1); tds->draw("yhat:rw");
  pad->cd(2); tds->draw("yhat:r");
  pad->cd(3); tds->draw("yhat:tu");
  pad->cd(4); tds->draw("yhat:tl");
  pad->cd(5); tds->draw("yhat:hu");
  pad->cd(6); tds->draw("yhat:hl");
  pad->cd(7); tds->draw("yhat:l");
  pad->cd(8); tds->draw("yhat:kw");
        
}
