  
{

  Int_t nS = 400;
  // Define the DataServer
  TDataServer *tds = new TDataServer("tdsflowrate", "DataBase flowrate");
  tds->addAttribute( new TUniformDistribution("rw", 0.05, 0.15));
  tds->addAttribute( new TUniformDistribution("r", 100.0, 50000.0));
  tds->addAttribute( new TUniformDistribution("tu", 63070.0, 115600.0));
  tds->addAttribute( new TUniformDistribution("tl", 63.1, 116.0));
  tds->addAttribute( new TUniformDistribution("hu", 990.0, 1110.0));
  tds->addAttribute( new TUniformDistribution("hl", 700.0, 820.0));
  tds->addAttribute( new TUniformDistribution("l", 1120.0, 1680.0));
  tds->addAttribute( new TUniformDistribution("kw", 9855.0, 12045.0));

  // The reference input file
  TString sIn = gSystem->pwd() + TString("/");
  sIn += TString("flowrate_input_with_keys.in");
  tds->getAttribute("rw")->setFileKey(sIn, "Rw");
  tds->getAttribute("r")->setFileKey(sIn, "R");
  tds->getAttribute("tu")->setFileKey(sIn, "Tu");
  tds->getAttribute("tl")->setFileKey(sIn, "Tl");
  tds->getAttribute("hu")->setFileKey(sIn, "Hu");
  tds->getAttribute("hl")->setFileKey(sIn, "Hl");
  tds->getAttribute("l")->setFileKey(sIn, "L");
  tds->getAttribute("kw")->setFileKey(sIn, "Kw");
  
  // Generate the sample
  TSampling *sampling = new TSampling(tds, "lhs", nS); 
  sampling->generateSample();   
  
  // The output file of the code
  TOutputFileRow *fout = new TOutputFileRow("_output_flowrate_withRow_.dat");
  // The attribute in the output file
  TAttribute * tyhat = new TAttribute("yhat");
  tyhat->setDefaultValue(-200.0);
  fout->addAttribute(tyhat);
  
  // Create a TCode object
  TCode *mycode = new TCode(tds, "flowrate -s -kf");
  // Add the output file where to find the output attributes
  //  mycode->addInputFile(new TInputFile(sIn));
  mycode->addOutputFile( fout );
  
  // Create a TLauncher object from a TDataServer and a TCode objects
  TLauncher *lanceur = new TLauncher(tds, mycode);
  lanceur->setSave();
  // lanceur->setClean();
  lanceur->setVarDraw("hu:hl","yhat>0","");
  // lanceur->setWorkingDirectory(gSystem->Getenv("PWD") + TString("/tmpLanceurUranie/flowrate"));

  lanceur->run();


   // Visualisation
   TCanvas  *Canvas = new TCanvas("c1", "Graph for the Macro launchCodeFlowratestop",5,64,1270,667);
   tds->draw("hu:hl","yhat>0");
   
   
  
  tds->exportData("_flowrate_sampler_launcher_.dat");
}
