{
  //Create dataserver with the seed attribute
  TDataServer *tds = new TDataServer("foo","pouet");
  tds->addAttribute( new TUniformDistribution("seed",0,100000));
  tds->getAttribute("seed")->setFileKey("multitype_input.dat","", "%e",TAttributeFileKey::kNewRow);

  //Create DOE
  TSampling *tsam = new TSampling(tds,"lhs",100);
  tsam->generateSample();

  //Precise output and create Code
  TOutputFileColumn *out = new TOutputFileColumn("_output_multitype_mt_Column_.dat");
  out->addAttribute(new TAttribute("w1",TAttribute::kString),1);
  out->addAttribute(new TAttribute("w2",TAttribute::kString),5);
  out->addAttribute(new TAttribute("v1",TAttribute::kVector),2);
  out->addAttribute(new TAttribute("v2",TAttribute::kVector),3);
  out->addAttribute(new TAttribute("f1"),4);
  TCode *myc = new URANIE::Launcher::TCode(tds, "multitype -mtCol");
  myc->addOutputFile( out );

  //Create TLauncher and run it
  TLauncher *tlau = new URANIE::Launcher::TLauncher(tds, myc);
  tlau->run();

  //Produce control plot
  TCanvas *Can = new TCanvas("Can","Can",10,10,1000,800);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw(); pad->cd();
  tds->drawPairs("w1:v1:v2:f1:w2");
  
}
  