{
  //Create dataserver with a database of 10 runs of the "multitype -mt" code
  TDataServer *tds = new TDataServer("foo","pouet");
  tds->fileDataRead("readmultitype_sampling.dat"); 

  //Explain the name of the input file and the format chosen
  tds->getAttribute("w1")->setFileKey("_output_multitype_mt_DataServer_.dat","", "%e",TAttributeFileKey::kNewTDS);
  tds->getAttribute("v1")->setFileKey("_output_multitype_mt_DataServer_.dat","", "%e",TAttributeFileKey::kNewTDS);
  tds->getAttribute("v2")->setFileKey("_output_multitype_mt_DataServer_.dat","", "%e",TAttributeFileKey::kNewTDS);
  tds->getAttribute("f1")->setFileKey("_output_multitype_mt_DataServer_.dat","", "%e",TAttributeFileKey::kNewTDS);
  tds->getAttribute("w2")->setFileKey("_output_multitype_mt_DataServer_.dat","", "%e",TAttributeFileKey::kNewTDS);    

  //Create the Class that will handle re-writting the input file
  TString OutName="_output_multitype_mt_DataServer_.dat";
  TInputFileRecreate *in = new TInputFileRecreate(gSystem->PrependPathName(gSystem->pwd(),OutName));

  // Add attribute in the correct (needed) order
  in->addAttribute( tds->getAttribute("w1") );
  in->addAttribute( tds->getAttribute("v1") );
  in->addAttribute( tds->getAttribute("v2") );
  in->addAttribute( tds->getAttribute("f1") );
  in->addAttribute( tds->getAttribute("w2") );

  // Create the output file interface and state that there will be 2 outputs 
  TOutputFileDataServer *out = new TOutputFileDataServer("_output_multitype_readmt_DataServer_.dat");
  out->addAttribute(new TAttribute("thev1") );
  out->addAttribute(new TAttribute("thev2") );

  // Create the corresponding interface to code
  TCode *tc1 = new TCode(tds, "multitype -ReadmtDS");
  tc1->addInputFile( in );
  tc1->addOutputFile( out );
  
  // Create the launcher and run the code
  TLauncher *tl1 = new TLauncher(tds, tc1);
  tl1->run();

  tds->Scan("thev1:thev2");
  
}
  