{
  //Create dataserver with a database of 10 runs of the "multitype -mt" code
  TDataServer *tds = new TDataServer("foo","pouet");
  tds->fileDataRead("readmultitype_sampling.dat"); 

  //Produce the input files
  gSystem->Exec("multitype -mtXML");

  //Explain the name of the input file and the format chosen
  tds->getAttribute("w1")->setFileKey("_output_multitype_mt_.xml","w1/@value", "", TAttributeFileKey::kXMLAttribute);
  tds->getAttribute("v1")->setFileKey("_output_multitype_mt_.xml","v1/values", "", TAttributeFileKey::kXMLField);
  tds->getAttribute("v2")->setFileKey("_output_multitype_mt_.xml","v2/values", "", TAttributeFileKey::kXMLField);
  tds->getAttribute("f1")->setFileKey("_output_multitype_mt_.xml","f1/@value", "", TAttributeFileKey::kXMLAttribute);
  tds->getAttribute("w2")->setFileKey("_output_multitype_mt_.xml","w2/@value", "", TAttributeFileKey::kXMLAttribute);    

  //Create the Class that will handle re-writting the input file
  TString OutName="_output_multitype_mt_.xml";
  TInputFileXML *in = new TInputFileXML(gSystem->PrependPathName(gSystem->pwd(),OutName));

  // Add attribute in the correct (needed) order
  in->addAttribute( tds->getAttribute("w1") );
  in->addAttribute( tds->getAttribute("v1") );
  in->addAttribute( tds->getAttribute("v2") );
  in->addAttribute( tds->getAttribute("f1") );
  in->addAttribute( tds->getAttribute("w2") );
  
  // Create the output file interface and state that there will be 2 outputs 
  TOutputFileXML *out = new TOutputFileXML("_output_multitype_readmt_.xml");
  out->addAttribute(new TAttribute("thev1"), "/flowrateREADMT/thev1/@value",  TAttributeFileKey::kXMLAttribute);
  out->addAttribute(new TAttribute("thev2"), "/flowrateREADMT/thev2/@value",  TAttributeFileKey::kXMLAttribute );

  // Create the corresponding interface to code
  TCode *tc1 = new TCode(tds, "multitype -ReadmtXML");
  tc1->addInputFile( in );
  tc1->addOutputFile( out );
  
  // Create the launcher and run the code
  TLauncher *tl1 = new TLauncher(tds, tc1);
  tl1->run();

  tds->Scan("thev1:thev2");
  
}
  