{
  // Create a TDataServer
  TDataServer * tds = new TDataServer();
  // Load the data set in the DataServer
  tds->fileDataRead("flowrateUniformDesign.dat");

  // Load the function in the UserFunction macros file
  gROOT->LoadMacro("UserFunctions.C");

  // Create a TLauncherFunction from a TDataServer and an analytical function
  // Rename the outpout attribute "ymod"
  TLauncherFunction * tlf = new TLauncherFunction(tds, "flowrateModel","","ymod");
  // Evaluate the function on all the points in the Design Of Experiments (DoE)
  tlf->run();
  
  // Graph
  TCanvas  *Canvas = new TCanvas("c1", "Graph for the Macro loadASCIIFile",5,64,1270,667);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw();
  pad->Divide(2,4);
  pad->cd(1); tds->draw("ymod:rw");
  pad->cd(2); tds->draw("ymod:r");
  pad->cd(3); tds->draw("ymod:tu");
  pad->cd(4); tds->draw("ymod:tl");
  pad->cd(5); tds->draw("ymod:hu");
  pad->cd(6); tds->draw("ymod:hl");
  pad->cd(7); tds->draw("ymod:l");
  pad->cd(8); tds->draw("ymod:kw");
        
}
