{
  TDataServer * tds = new TDataServer();
  tds->fileDataRead("flowrate_sampler_launcher_500.dat");
  
  TCanvas *c = new TCanvas("c1", "Graph for the Macro modeler",5,64,1270,667);
  c->Divide(2);
  c->cd(1); tds->draw("yhat:rw");

  // tds->getAttribute("yhat")->setOutput();
  
  TLinearRegression *tlin = new TLinearRegression(tds, "rw:r:tu:tl:hu:hl:l:kw", "yhat");
  tlin->estimate();  
    
  tlin->exportFunction("c++", "_FileContainingFunction_", "MultiLinearFunction");

  // Define the DataServer
  TDataServer *tds2 = new TDataServer("tdsFlowrate", "Design of experiments for Flowrate");

  // Add the study attributes 
  tds2->addAttribute( new TUniformDistribution("rw", 0.05, 0.15));
  tds2->addAttribute( new TUniformDistribution("r", 100.0, 50000.0));
  tds2->addAttribute( new TUniformDistribution("tu", 63070.0, 115600.0));
  tds2->addAttribute( new TUniformDistribution("tl", 63.1, 116.0));
  tds2->addAttribute( new TUniformDistribution("hu", 990.0, 1110.0));
  tds2->addAttribute( new TUniformDistribution("hl", 700.0, 820.0));
  tds2->addAttribute( new TUniformDistribution("l", 1120.0, 1680.0));
  tds2->addAttribute( new TUniformDistribution("kw", 9855.0, 12045.0));

  Int_t nS = 1000;
  //   \test Générateur de plan d'expérience
  TSampling *sampling = new TSampling(tds2, "lhs", nS);
  sampling->generateSample();   
     
  gROOT->LoadMacro("_FileContainingFunction_.C");
  
  // Create a TLauncherFunction from a TDataServer and an analytical function
  // Rename the outpout attribute "ymod"
  TLauncherFunction * tlf = new TLauncherFunction(tds2, "MultiLinearFunction","","ymod");
  // Evaluate the function on all the design of experiments
  tlf->run();
     
  c->Clear();
  tds2->getTuple()->SetMarkerColor(kBlue);
  tds2->getTuple()->SetMarkerStyle(8);
  tds2->getTuple()->SetMarkerSize(1.2);
  
  tds->getTuple()->SetMarkerColor(kGreen);
  tds->getTuple()->SetMarkerStyle(8);
  tds->getTuple()->SetMarkerSize(1.2);

  tds2->draw("ymod:rw");
  tds->draw("yhat:rw","","same");
     
}