"""
Example of Gaussian Process loading
"""
from rootlogon import DataServer, Modeler

# Load the model data file into a data server
# VERY IMPORTANT: do not give any name or title to this tds !
tdsModelData = DataServer.TDataServer()
tdsModelData.fileDataRead("modelData.dat")

# Create a GP builder based on this data server
gpb = Modeler.TGPBuilder(tdsModelData)

# Create the kriging model
krig = gpb.buildGP()

# Display model information
krig.printLog()
