{
  // Create the TDataServer
  TDataServer *tds = new TDataServer("foo","test");
  tds->fileDataRead("flowrateUniformDesign.dat");

  // Get the attributes
  TAttribute *rw = tds->getAttribute("rw");
  TAttribute *r = tds->getAttribute("r");
  TAttribute *tu = tds->getAttribute("tu");
  TAttribute *tl = tds->getAttribute("tl");
  TAttribute *hu = tds->getAttribute("hu");
  TAttribute *hl = tds->getAttribute("hl");
  TAttribute *l = tds->getAttribute("l");
  TAttribute *kw = tds->getAttribute("kw");

  // Create the output attribute
  TAttribute *yhat = new TAttribute("yhat");
  TAttribute *d = new TAttribute("d");
  
  // Set the reference input file and the key for each input attributes
  TFlatScript fin("flowrate_input_with_values_rows.in");
  fin.setInputs(8, rw, r, tu, tl, hu, hl, l, kw);

  // The output file of the code
  TFlatResult fout("_output_flowrate_withRow_.dat");
  fout.setOutputs(2, yhat, d);// Passing the attributes to the output file

  // Constructing the code
  TCodeEval mycode( "flowrate -s -rf" );    
  mycode.addInputFile(&fin); // Adding the input file
  mycode.addOutputFile(&fout); // Adding the output file

  // Create the sequential runner
  TSequentialRun run(&mycode);
  run.startSlave(); //Start the master (necessary even for a sequential)

  if (run.onMaster())
  {
      TLauncher2 lanceur(tds, &run);

      // Store the wrong calculation
      TDataServer error("WrongComputations","pouet");
      lanceur.setSaveError(&error);

      // resolution
      lanceur.solverLoop();
      run.stopSlave(); // Stop the slaves (necessary even for a sequential)

      // dump all wrong configurations
      error.getTuple()->SetScanField(-1);
      error.scan("*");
  }
  
  // Draw the result
  TCanvas *can = new TCanvas("pouet","foo",1);
  tds->Draw("hu:hl");
  
   
}
