{
 gROOT->LoadMacro("UserFunctions.C");
 
 // Define the DataServer
 TDataServer *tds = new TDataServer("tdsflowrate", "DataBase flowrate");
 tds->addAttribute( new TUniformDistribution("rw", 0.05, 0.15));
 tds->addAttribute( new TUniformDistribution("r", 100.0, 50000.0));
 tds->addAttribute( new TUniformDistribution("tu", 63070.0, 115600.0));
 tds->addAttribute( new TUniformDistribution("tl", 63.1, 116.0));
 tds->addAttribute( new TUniformDistribution("hu", 990.0, 1110.0));
 tds->addAttribute( new TUniformDistribution("hl", 700.0, 820.0));
 tds->addAttribute( new TUniformDistribution("l", 1120.0, 1680.0));
 tds->addAttribute( new TUniformDistribution("kw", 9855.0, 12045.0));
 
 // Set the Morris method parameters
 Int_t nreplica = 3;
 Int_t nlevel = 10;
 
 // Create a TMorris object
 TMorris * scmo = new TMorris(tds, "flowrateModel", nreplica, nlevel);
 
 // generate a Morris sample
 scmo->generateSample();
 
 //Save the sample
 tds->exportData("_morris_sampling_.dat");   
 
 // compute the Morris screening measures
 scmo->computeIndexes();
 
 // Display graphically the Morris screanig measures
 TCanvas *cc = new TCanvas("can", "histogramme");
 TPad *apad = new TPad("apad","apad",0, 0.03, 1, 1); apad->Draw(); apad->cd();
 scmo->drawIndexes("mustar,nonewcanv");
 
  }