
void flowrateModel(double *x, double *y)
{
  Double_t drw = x[1], dr  = 25050;
  Double_t dtu = 89335, dtl = 89.55;
  Double_t dhu = 1050, dhl = x[0];
  Double_t dl  = x[2], dkw = 10950;

  Double_t dnum = 2.0 * TMath::Pi() * dtu * ( dhu -dhl);
  Double_t dlnronrw = TMath::Log( dr / drw);
  Double_t dden = dlnronrw * ( 1.0 +  ( 2.0 * dl * dtu ) / ( dlnronrw * drw * drw * dkw) + dtu / dtl );

  y[0] = dnum / dden;
}
