/*//////////////////////////////////////////////////////////////
 // Copyright (C) 2013-2024 CEA/DES
 //
 // This program is free software: you can redistribute it and/or modify
 // it under the terms of the GNU Lesser General Public License as published
 // by the Free Software Foundation, either version 3 of the License, or any
 // later version.
 //
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU Lesser General Public License for more details.
 //
 // You should have received a copy of the GNU Lesser General Public License
 // along with this program. If not, see <http://www.gnu.org/licenses/>.
 //////////////////////////////////////////////////////////////
 //////////////////////////////////////////////////////////////
 // $Id$
 // $Author$
 // $Date$
 // $Revision$
 // $State$
 //////////////////////////////////////////////////////////////*/
/*!
 \file   matrice.h
 \author Jean-Marc Martinez <jean-marc.martinez@cea.fr>
 \date   2012/07/19 15:38:00

 \brief
 */
#ifdef WIN32
#include "libpgauss_Export.h"
#else
#define libpgauss_EXPORT
#endif

libpgauss_EXPORT struct matrice
{
    int n;
    int p;
    double *x;
};
libpgauss_EXPORT struct matrice * alloueMatrice(int n, int p);
libpgauss_EXPORT double element(struct matrice *a, int i, int j);
libpgauss_EXPORT struct matrice * produitMatriceAB(struct matrice *a, struct matrice *b);
libpgauss_EXPORT struct matrice * produitMatriceAtB(struct matrice *a, struct matrice *b);
libpgauss_EXPORT void svdDecomposition(struct matrice *H, struct matrice *U, double *S,
        struct matrice *V);
libpgauss_EXPORT void printMat(struct matrice * a, char *);
