//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdlib.h>
#include <math.h>
#include "fct_integ_adaptatif.hpp" 

//! sort indices constant
#define RANK_INDICE 27

//#include <unistd.h>
//#include "gnuplot_i.hpp"

namespace Anisp
{

double CATP_carre(void (*function)(std::vector<double*>), void (*step_by_step)(double*,std::vector<int*>),int d,
		  int l,int m, int max, double tol,int* ni, int* nld,
		  std::vector<double*>* N,std::vector<double*>*H, std::vector<double*>* P, std::vector<int>* O, 
		  std::vector<int*>* V,std::vector<int>* S, int kmin, std::string loi, 
		  bool rep, bool log, std::string DataAnispFile, std::string ErrorIndicatorFile,
		  std::string IndicesFile)// Integration adaptative d'une fonction avec l'algorithme CATP avec ensemble d'indices admissible
{
int n,nl,p,nk,a,aa,b,c,C,mk,mk2;
double r,gi,delta_1,delta_j,coef,eta,eta1,s;
// double* yy = new double;
n = int(pow(2.0,d+0.0))-1;
nl = int(pow(2.0,l+0.0))-1; // quadrature de fejer
int nRI = int(pow(2.0,RANK_INDICE+0.0))-1;// sort points constant
C = 100;
*nld = 0;
double* K = new double[d];
int* indi = new int[d];
int* indj = new int[d];
int* indk = new int[d];
int** I = new int*[m];
double** G = new double*[m];
double** Delta = new double*[nl];
double** Delta_n = new double*[nl];

std::vector<double*> ExpPoints;
std::vector<int*> IndicesIteration;



const char* data = DataAnispFile.c_str();
// char nomfich[11] = "indice.dat";

const char * nomfich = IndicesFile.c_str(); 
std::ofstream indice (nomfich,std::ios::out);

// char nomfich1[11] = "erreur.dat";

const char * nomfich1 = ErrorIndicatorFile.c_str();
std::ofstream err (nomfich1,std::ios::out);

for(int i=0;i<m;i++)
  {
   I[i] = new int[d+1];
   for(int j=0;j<d+1;j++)
      I[i][j]=0;
   G[i] = new double[3];
  } 
  
for(int i=0;i<nl;i++)
  {
   Delta[i] = new double[l+1];  
   Delta_n[i] = new double[l+1];  
  }

int * ind = new int[d];


double* vp = new double[d+2];
double* vh = new double[2];
double* vn = new double[2];
int* vv = new int[d];


std::vector<double*>* Ikmin = new std::vector<double*>;
(*Ikmin).reserve(m);
double* vkmin = new double[2]; 
int nkmin;
int* nkm = new int;



 //--------calcul de Delta -----------------------

for(int i=0;i<d;i++)
  {
   if(loi[i]=='n')
    {
     calcul_delta_n(Delta_n,l);//va normale
     break;
    }
  }

calcul_delta(Delta,l);//va uniforme

//--------fin du calcul de Delta ------------------
int** Cq = new int*[d];
for(int i=0;i<d;i++)
  Cq[i] = new int[2];

int count=0;
double * vd = new double[3];
int* vind;
double* vpoint;

if(!rep)
{
//---calcul du premier terme (1,1,...,1)---------------

for(int i=0;i<d;i++)
  {
   Cq[i][1] = int(comb(d+0.0,i+1.0));
   Cq[i][0] = 0;
  }

for(int i=0;i<d;i++)
  {
   indi[i] = 1; 
  }  


 for(int i=0;i<m;i++)
   {
    G[i][0] = 0;
    G[i][1] = -1;
    G[i][2] = -1;
   }
//  int* vind = new int[d];    
 vind = new int[d];
 for(int i=0;i<d;i++)
   { 
    I[0][i] = indi[i];
    vind[i] = I[0][i];
    indice<<I[0][i]<<"    ";
    vp[i] = 0.0; 
   }  
 indice<<std::endl;
 I[0][d] = -1;   
 *ni = 1;  
 IndicesIteration.push_back(vind);
 
//distributed 
// double* vpoint;
vpoint = vp;
ExpPoints.push_back(vpoint);
//distributed  

//  function(vp,yy);
//  s = yy[0];
try
{
    function(ExpPoints);
 
}
catch( std::exception &)
{
//Clean

    delete[] K;
    K = NULL;
    delete[] indi;
    indi = NULL;
    delete[] indj;
    indj = NULL;
    delete[] indk;
    indk = NULL;
    
    for (int idel = 0; idel < m; idel++)
    {
        delete[] I[idel];
        I[idel] = NULL;
        delete[] G[idel];
        G[idel] = NULL;
    }
    delete[] I;
    I = NULL;
    delete[] G;
    G = NULL;
    
    for (int idel = 0; idel < nl; idel++)
    {
        delete[] Delta[idel];
        Delta[idel] = NULL;
        delete[] Delta_n[idel];
        Delta_n[idel] = NULL;
    }
    delete[] Delta;
    Delta = NULL;
    delete[] Delta_n;
    Delta_n = NULL;
    
     for (int idel = 0; idel < int((*Ikmin).size()); idel++)
    {
        delete[] (*Ikmin)[idel];
        (*Ikmin)[idel] = NULL;
    }
    (*Ikmin).clear();
    delete Ikmin;
    Ikmin = NULL;
    
    delete[] ind;
    ind = NULL;
    delete[] vp;
    vp = NULL;
    delete[] vh;
    vh = NULL;
    delete[] vn;
    vn = NULL;
    delete[] vv;
    vv = NULL;
    delete[] vkmin;
    vkmin = NULL;
    delete nkm;
    nkm = NULL;
    
    for (int idel = 0; idel < d; idel++)
    {
        delete[] Cq[idel];
        Cq[idel] = NULL;
    }
    delete[] Cq;
    Cq = NULL;
    delete[] vd;
    vd = NULL;
    
    for (int idel = 0; idel < int(IndicesIteration.size()); idel++)
    {
        delete[] IndicesIteration[idel];
    }
    IndicesIteration.clear();
   
//////////
    
    

    throw;
    
}


 s = ExpPoints[0][d];
 
 r = s*s;

 delta_1 = s*s;





std::make_heap(G,G+m,inf2);

vp[d] = s;
vp[d+1] = 1;

for(int i=0;i<d;i++)  //fejer
   K[i] = int(pow(2.0,l-1.0))-1;

vh[0] = h(K,d,nl);
// vh[0] = h(K,d,nRI);
vh[1] = 0;
(*P).push_back(vp); 
(*H).push_back(vh);
vp = new double[d+2];
vh = new double[2];

for(int i=0;i<d;i++)  
   K[i] = 1;
// vn[0] = h(K,d,l);
vn[0] = h(K,d,RANK_INDICE);
vn[1] = 0;
(*N).push_back(vn); 
vn = new double[2];
   
*nld = 1;

//distributed 
// cout<<"test  "<<ExpPoints[0][d]<<endl;
ExpPoints.clear();
//distributed 

//----fin du calcul du premier terme ----------  

for(int i=0;i<n;i++)
  {
   
 
     nk=1;
     for(int j=0;j<d;j++) //fejer
        {
         nk = nk * (int(pow(2.0,indi[j]+1.0))-1);
	}
    
     
  } 


eta = 0.0;
eta1 = 0.0;


c = 0;

}
else{
recupere_data(data,d,n,m,nld,P,H,N,V,S, Ikmin,ni,I,G,vd,nkm,Cq);
eta = vd[0];
eta1 = vd[1];
r = vd[2];
c = *nkm;
if(log){
    std::cout<<"number of points computed during the precedent calcul:  "<<*nld<<std::endl;
    
}
std::make_heap(G,G+m,inf2);
}

//--calcul de la premiere étape------------------

nkmin = 0;
for(int i=1;i<kmin+1;i++)
  {
   nkmin = nkmin + int(comb(d+0.0,i+0.0));
  } 

for(int i=c;i<nkmin;i++) 
   { 
     calcul_ind(ind,i,d);
     p = 0;
     mk=0;
//      int* vind = new int[d];
     vind = new int[d];
     for(int j=0;j<d;j++)
        {   
         
         indi[j] = ind[j] + 1;
	 I[*ni][j] = indi[j];
	 vind[j] = indi[j];
         indice<<indi[j]<<"    ";
	 K[j] = indi[j];
	 if(indi[j]>1) 
         p = p +int(pow(2.0,j+0.0));
     mk = mk +indi[j];
	} 
	indice<<std::endl;
     IndicesIteration.push_back(vind);
     mk = mk-d-1;
     vkmin[1] = i;
     I[*ni][d] = p;
//      vn[0] = h(K,d,l);
     vn[0] = h(K,d,RANK_INDICE);
     vkmin[0] = vn[0];
     vn[1] = *ni;
     
     if(binary_search((*N).begin(),(*N).end(),vn,inf2) == false)
//      if(!simple_search(indi,I,m,l))
    {
     (*N).insert(lower_bound((*N).begin(),(*N).end(),vn,inf2),vn);  
     vn = new double[2];
     Cq[mk][0] = Cq[mk][0] + 1;
     delta_j = 0.0;
     nk=1;
     for(int j=0;j<d;j++) //fejer
        {
	 nk = nk * (int(pow(2.0,indi[j]+0.0))-1);
	}
   
     for(int j=0;j<nk;j++)
	{       
	 coef = 1;
	 p = nk;
	 for(int kk=0;kk<d;kk++)
	    {
             a = indi[kk];
	     b = int(pow(2.0,a+0.0))-1; //fejer
	     p = p/b;
	     aa = int(pow(2.0,l-a+0.0))*((j/p)%b +1)-1; // fejer
	     K[kk] = aa; 
             if(loi[kk]=='u')
              {
	       coef = coef* Delta[aa][a];
               vp[kk] = Delta[aa][0];
              }  
             else
              {
               coef = coef* Delta_n[aa][a];
	       vp[kk] = Delta_n[aa][0];
              }
	    }
	  vh[0] = h(K,d,nl);
// 	  vh[0] = h(K,d,nRI);
	  vh[1] = *nld;
	
	  if(binary_search((*H).begin(),(*H).end(),vh,inf2) == false)
	    {
	     
	     //distributed 
// 	     double* vpoint;
	     vpoint = vp;
	     ExpPoints.push_back(vpoint);
	     //distributed  

		
//              function(vp,yy);
// 	     s = yy[0];
             s = 0;
	     
	     vp[d] = s;
	     vp[d+1] = coef;
	     (*P).insert((*P).end(),vp);
	     (*H).insert(lower_bound((*H).begin(),(*H).end(),vh,inf2),vh);
	     
	     vh = new double[2];
//              delta_j = delta_j + coef*s*s;
	     vp = new double[d+2];
	     *nld = *nld+1;
         count = count +1;  
	
	    } 
	  else{
	    
	    s = (*P)[int(*(*(lower_bound((*H).begin(),(*H).end(),vh,inf2))+1))][d];
	    (*P)[int(*(*(lower_bound((*H).begin(),(*H).end(),vh,inf2))+1))][d+1] = (*P)[int(*(*(lower_bound((*H).begin(),(*H).end(),vh,inf2))+1))][d+1] + coef;
            delta_j = delta_j + coef*s*s; 
	       }
         
	 
	} 
      //distributed
	 if(ExpPoints.size()>0)
	 {
	  function(ExpPoints);
	  for(int i_pt=0;i_pt<int(ExpPoints.size());i_pt++)
	     delta_j = delta_j + ExpPoints[i_pt][d+1]*ExpPoints[i_pt][d]*ExpPoints[i_pt][d];
	  ExpPoints.clear();
	 }
      //distributed 	
	
     
     r = r + delta_j;
     *ni = *ni + 1;
     gi = fabs(delta_j);
     eta1 = eta1 + gi;
     if(gi>1.0E-16) 
      {
       
       eta = eta + gi;
       if(G[m-1][0]==0){ 
         G[m-1][2] = i;  
	 G[m-1][1] = *ni-1;   
	 G[m-1][0] = gi; 
         std::push_heap(G,G+m,inf2);
        }
       else{
	  std::sort_heap(G,G+m,inf2);
	  std::make_heap(G,G+m,inf2);
	  G[m-1][2] = i;
	  G[m-1][1] = *ni-1;   
	  G[m-1][0] = gi; 
          std::push_heap(G,G+m,inf2);
         }   
      } 
     else{ 
       (*O).push_back(*ni-1);
      }
   }

  } 
   
 
for(int j=0;j<comb(d,kmin);j++)
  {
   nk = nkmin-j-1;
   calcul_ind(ind,nk,d);
   for(int i=0;i<d;i++)
      {
	vv[i] = ind[i];
      }
   (*V).push_back(vv);
   vv = new int[d];
  }
  
//enditeration
double* verror= new double[2];

    verror[0] = *nld;
    verror[1] = eta;
    step_by_step(verror,IndicesIteration);
    for (int idel = 0; idel < int(IndicesIteration.size()); idel++)
    {
        delete[] IndicesIteration[idel];
    }
    IndicesIteration.clear();


//-----fin de la première étape---------------------

//-----début de la boucle principale--------------
int nindi,u,u1,u2,u3,uu=-99,it;
u=0;


 while( eta>tol && *nld<max ) 
   {
    err<<*nld<<"   "<<std::setw(25)<<std::setprecision(25)<<eta<<std::endl;
    nindi = int(G[0][1]);
    mk = 1;
    for(int k=0;k<d;k++)
      {
      indi[k] = I[nindi][k];
      if(indi[k]==l) 
      {
          u=-1;
      }
      if(indi[k]>mk) 
          mk = indi[k];
      }
    if(u==-1)
     {
      if(log)
      {
          std::cout<<"Program stops, l max reached "<<std::endl;
      }
      break;
     }  
    eta = eta - G[0][0];
    eta1 = eta1- G[0][0];
    u = int(G[0][2]);
    std::pop_heap(G,G+m,inf2);
    G[m-1][0] = 0;
    G[m-1][1] = -1;
    G[m-1][2] = -1;      

    if(mk==2)
     {
      for(int j=0;j<d;j++)
        {
         K[j] = indi[j];
         ind[j] = indi[j]-1;
        }
//       vkmin[0] = h(K,d,l);
      vkmin[0] = h(K,d,RANK_INDICE);
      vkmin[1] = calcul_ni(ind,d);
      
      (*S).push_back(int(vkmin[1]));
      (*Ikmin).insert(lower_bound((*Ikmin).begin(),(*Ikmin).end(),vkmin,inf2),vkmin);
      vkmin = new double[2];
     }

   calcul_ind(ind,u,d);

    for(int k=0;k<d;k++)
      {
        if(ind[k]==1 || mk==2)
         {
          for(int j=0;j<d;j++)
	    {
             indj[j] = indi[j];
	     K[j] = indi[j];
	    }
          indj[k] = indj[k] +1;
	  K[k] = indj[k];
           for(int j=0;j<d;j++)
               indk[j] = indj[j]-1;
// 	  vn[0] = h(K,d,l) ;
	  vn[0] = h(K,d,RANK_INDICE) ;
	  vn[1] = *ni;
	  
	  if(binary_search((*N).begin(),(*N).end(),vn,inf2) == false)
// 	   if(!simple_search(indj,I,m,d))
	    {
               a = 1;
             mk2 = 1;
             for(int i=0;i<d;i++)
               {
                if(indj[i]>mk2) 
                    mk2 = indj[i];
               }
             if(mk2==2)
              {
               for(int i=0;i<k-1;i++)
                {
                 for(int j=0;j<d;j++)
                    K[j] = indj[j];
                 K[i] = K[i] - 1; 
// 		 vkmin[0] = h(K,d,l);
                 vkmin[0] = h(K,d,RANK_INDICE);
                 if(binary_search((*Ikmin).begin(),(*Ikmin).end(),vkmin,inf2)==false)
                   {
                    a = 0;
                    if(K[i]==0)
                        a=1;
                   }
                 } 
               for(int i=k+1;i<d;i++)
                {
                 for(int j=0;j<d;j++)
                    K[j] = indj[j];
                 K[i] = K[i] - 1; 
// 		 vkmin[0] = h(K,d,l);
                 vkmin[0] = h(K,d,RANK_INDICE);
                 if(binary_search((*Ikmin).begin(),(*Ikmin).end(),vkmin,inf2)==false)
                   { 
                    a = 0;
                    if(K[i]==0)
                        a=1;
                   }
                 }
               vkmin[0] = vn[0];
               vkmin[1] = calcul_ni(indk,d);
               
              }
           if(a==1)
            {
	     (*N).insert(lower_bound((*N).begin(),(*N).end(),vn,inf2),vn);
// 	     int* vind = new int[d];
         vind = new int[d];
	     for(int i=0;i<d;i++)
               {
	        I[*ni][i] = indj[i];
		vind[i] = indj[i];
                indice<<indj[i]<<"    ";
               }
               indice<<std::endl;
	     IndicesIteration.push_back(vind);
             if(mk2==2)
              {
               I[*ni][d] = int(vkmin[1]);
               uu = int(vkmin[1]);
               a = 0;
               calcul_ind(indk,uu,d);
               for(int i=0;i<d;i++)
                 {
                  // MODIFICATION 07 mars 2011
                  // remplacement de ind par indk
                  // car pour kmin = 1 on obtenait des Cq[0][0] > Cq[1][0] !!
                  if(indk[i]==1)
                     a = a + 1;
                 }
               a = a-1;
               Cq[a][0] = Cq[a][0] + 1;
               //cout << "MODIF "<<Cq[a][0] << endl;
              } 
            else
               I[*ni][d] = I[nindi][d];
	    // test angles
            for(int j1=0;j1<d;j1++)
	       vv[j1] = indj[j1];
	    a = 0; 
        u3 = 1;
	    for(unsigned i1=0;i1<(*V).size();i1++)
	       {
	        u1 = 1;
            u2=0;
	        for(int j1=0;j1<d;j1++)
		  {
		   if(indj[j1]-(*V)[i1][j1] < 0)
		     {
		      u1=0;
		     } 
		   else{
               if(indj[j1]-(*V)[i1][j1] > 0)
                   u2 = 1;
               
            }   
		  }
		if(u1==1)
        { 
            delete[] (*V)[i1];
            (*V).erase((*V).begin()+i1);
            a = 1;      
        }
		if(u2==0)
        {
            u3 = 0;           
        }  
	       }
	    if(a==1 || u3==1)
        {
            (*V).push_back(vv); 
            vv = new int[d];
            
        } 
	    // fin test angles
	    delta_j = 0.0;
            nk=1;
            for(int j=0;j<d;j++) //fejer
              {
	       nk = nk * (int(pow(2.0,indj[j]+0.0))-1);
	      }
            if(mk2==2)
             {
              it = I[*ni][d];
             }

            for(int j=0;j<nk;j++)
	      {       
	       coef = 1; 
	       p = nk;
	       for(int kk=0;kk<d;kk++)
	         {
                  a = indj[kk];
	          b = int(pow(2.0,a+0.0))-1; //fejer
	          p = p/b;
	          aa = int(pow(2.0,l-a+0.0))*((j/p)%b +1)-1; // fejer
	          K[kk] = aa; 
	          if(loi[kk]=='u')
                   {
	            coef = coef* Delta[aa][a];
                    vp[kk] = Delta[aa][0];
                   }  
                  else
                   {
                    coef = coef* Delta_n[aa][a];
	            vp[kk] = Delta_n[aa][0];
                   }
	         }
	       vh[0] = h(K,d,nl);
// 	       vh[0] = h(K,d,nRI);
	       vh[1] = *nld;
               
	       if(binary_search((*H).begin(),(*H).end(),vh,inf2) == false)
	         {
		   //distributed 
// 		   double* vpoint;
		   vpoint = vp;
		   ExpPoints.push_back(vpoint);
		   //distributed
		     
	          //s = f(chgt_var(vp,d,loi));
//                   function(vp,yy);
// 		  s = yy[0];
                  s = 0;
                  count=count+1;
	          vp[d] = s;
		  vp[d+1] = coef;
	          (*P).insert((*P).end(),vp);
	          (*H).insert(lower_bound((*H).begin(),(*H).end(),vh,inf2),vh); 
		 
	          vh = new double[2];
                  delta_j = delta_j + coef*s*s;
	          vp = new double[d+2];
	          *nld = *nld+1;  
                   
	         } 
	       else{
                  
	          s = (*P)[int(*(*(lower_bound((*H).begin(),(*H).end(),vh,inf2))+1))][d];
		  (*P)[int(*(*(lower_bound((*H).begin(),(*H).end(),vh,inf2))+1))][d+1] = (*P)[int(*(*(lower_bound((*H).begin(),(*H).end(),vh,inf2))+1))][d+1] + coef;
                  delta_j = delta_j + coef*s*s; 
	         }
		 
	        
	      } 
	       //distributed 
	       if(ExpPoints.size()>0)
	        {
	         function(ExpPoints);
	         for(int i_pt=0;i_pt<int(ExpPoints.size());i_pt++)
		    delta_j = delta_j + ExpPoints[i_pt][d+1]*ExpPoints[i_pt][d]*ExpPoints[i_pt][d];
// 		    cout<<"test  "<<ExpPoints[i_pt][d]<<endl;
	          
	         ExpPoints.clear();
	        }
	       //distributed 	
	       
	       
               r = r + delta_j;
               *ni = *ni + 1;
	   gi = fabs(delta_j);  
            eta1 = eta1 + gi;
            if(gi>1.0E-16) 
              {
               eta = eta + gi;
               if(G[m-1][0]==0)
               {
                 if(mk2==2)
                   { 
                    G[m-1][2] = uu;
                    
                   }
                 else 
                     G[m-1][2] = u;  
	         G[m-1][1] = *ni-1;   
	         G[m-1][0] = gi; 
                 std::push_heap(G,G+m,inf2);
                }
               else
               {
	          std::sort_heap(G,G+m,inf2);
	          std::make_heap(G,G+m,inf2);
                  if(mk2==2)
                   {
                    G[m-1][2] = uu;
                   
                   }
                  else 
                      G[m-1][2] = u;
	          G[m-1][1] = *ni-1;   
	          G[m-1][0] = gi; 
                  std::push_heap(G,G+m,inf2);
                 }   
               }
	     else
	       {
	         (*O).push_back(*ni-1);
		 
	       }    
             vn = new double[2];
	     }
	    }   
         }
      }
   //enditeration   

	verror[0] = *nld;
	verror[1] = eta;
	step_by_step(verror,IndicesIteration);
    for (int idel = 0; idel < int(IndicesIteration.size()); idel++)
        {
            delete[] IndicesIteration[idel];
        }
	IndicesIteration.clear();
    
   } 

//for(int i=0;i<100;i++)
// cout<<(*P)[i][1]<<"     "<<endl; 

err<<*nld<<"     "<<std::setw(25)<<std::setprecision(25)<<eta<<std::endl;
err.close();
//----fin de la boucle principale------------------
if(rep && log)
 {
  std::cout<<"Number of calculated additional points:  "<<count<<std::endl;
  std::cout<<"difference between the old and the new values of the square L2 norm:  "<<std::endl;
 std::cout<<vd[2]-r<<std::endl;
 }

if(eta<tol)
{
    if(log)
        std::cout<<"tolerance reached"<<std::endl;
}
else
{
    if(log)
    {
        std::cout<<"tolerance not reached"<<std::endl;
        std::cout<<"value of the error indicator on the integral: "<<eta<<std::endl;
    }
}
//---complément-----------------------------------------


sauvegarde_data(data,d,n,m,nld,P,H,N,V,S,Ikmin,ni,I,G,eta,eta1,r,nkmin,Cq);
int* X = new int[d]; 
for(unsigned i=0;i<(*V).size();i++)
  {
   for(int j=0;j<d;j++)
     X[j] = (*V)[i][j];           
    ens_adm(d,l,X,I,N,H,P,Delta,Delta_n,loi,nld,O); 
  }

*ni = (*N).size();

  

for(int i=0;i<d;i++)
  {
   if(Cq[i][0]!=Cq[i][1])
     {
      if(log)
      {
          std::cout<<"next value of kmin advised: "<<i+1<<std::endl;
          
      }
      break;
     }
  }

  indice.close();
  // char nomfich[11] = "indice.dat";
   std::ofstream indices (nomfich,std::ios::out); 
 
   for(int i=0;i<*ni;i++)
     {
      for(int j=0;j<d;j++)
         {
          indices<<I[i][j]<<"   ";
         } 
       indices<<std::endl;
     }       
   indices.close();
  

//Clean

    delete[] K;
    K = NULL;
    delete[] indi;
    indi = NULL;
    delete[] indj;
    indj = NULL;
    delete[] indk;
    indk = NULL;
    
    for (int idel = 0; idel < m; idel++)
    {
        delete[] I[idel];
        I[idel] = NULL;
        delete[] G[idel];
        G[idel] = NULL;
    }
    delete[] I;
    I = NULL;
    delete[] G;
    G = NULL;
    
    for (int idel = 0; idel < nl; idel++)
    {
        delete[] Delta[idel];
        Delta[idel] = NULL;
        delete[] Delta_n[idel];
        Delta_n[idel] = NULL;
    }
    delete[] Delta;
    Delta = NULL;
    delete[] Delta_n;
    Delta_n = NULL;
    
     for (int idel = 0; idel < int((*Ikmin).size()); idel++)
    {
        delete[] (*Ikmin)[idel];
        (*Ikmin)[idel] = NULL;
    }
    (*Ikmin).clear();
    delete Ikmin;
    Ikmin = NULL;
    
    delete[] ind;
    ind = NULL;
    delete[] vp;
    vp = NULL;
    delete[] vh;
    vh = NULL;
    delete[] vn;
    vn = NULL;
    delete[] vv;
    vv = NULL;
    delete[] vkmin;
    vkmin = NULL;
    delete nkm;
    nkm = NULL;
    
    for (int idel = 0; idel < d; idel++)
    {
        delete[] Cq[idel];
        Cq[idel] = NULL;
    }
    delete[] Cq;
    Cq = NULL;
    delete[] vd;
    vd = NULL;
    
    delete[] verror;
    verror = NULL;
    delete[] X;
    X = NULL;
    
//     for (int idel = 0; idel < ExpPoints.size(); idel++)
//     {
//         delete[] ExpPoints[idel];
//     }
    ExpPoints.clear();
   
  return r;
}


void sauvegarde_data( const char* data, int d, int n, int m,  int* nld, std::vector<double*>* P,std::vector<double*>* H, std::vector<double*>* N, std::vector<int*>*  V, std::vector<int>* S, std::vector<double*>* Ikmin, int* ni, int** I, double** G, double eta, double eta1, double r, int nkmin,int** Cq)
{

    (void)(n);
std::ofstream dat(data,std::ios::out);
dat<<*nld<<std::endl;

for(int i=0;i<*nld;i++)
   {
    for(int j=0;j<d+2;j++)
      dat<<std::setw(25)<<std::setprecision(20)<<(*P)[i][j]<<"       ";
     dat<<std::endl;
   }

dat<<std::endl;
dat<<(*H).size()<<std::endl;

for(unsigned i=0;i<(*H).size();i++)
   {
    dat<<std::setw(25)<<std::setprecision(20)<<(*H)[i][0]<<"       ";
    dat<<std::setw(25)<<std::setprecision(20)<<(*H)[i][1]<<std::endl;
   }

dat<<std::endl;
dat<<(*N).size()<<std::endl;

for(unsigned i=0;i<(*N).size();i++)
   {
    dat<<std::setw(25)<<std::setprecision(20)<<(*N)[i][0]<<"       ";
    dat<<std::setw(25)<<std::setprecision(20)<<(*N)[i][1]<<std::endl;
   }

dat<<std::endl;
dat<<(*V).size()<<std::endl;

for(unsigned i=0;i<(*V).size();i++)
   {
    for(int j=0;j<d;j++)
      dat<<std::setw(25)<<std::setprecision(20)<<(*V)[i][j]<<"       ";
     dat<<std::endl;
   }

dat<<std::endl;
dat<<(*S).size()<<std::endl;

for(unsigned i=0;i<(*S).size();i++)
   dat<<std::setw(25)<<std::setprecision(20)<<(*S)[i]<<std::endl;

dat<<std::endl;
dat<<(*Ikmin).size()<<std::endl;

for(unsigned i=0;i<(*Ikmin).size();i++)
   {
    dat<<std::setw(25)<<std::setprecision(20)<<(*Ikmin)[i][0]<<"       ";
    dat<<std::setw(25)<<std::setprecision(20)<<(*Ikmin)[i][1]<<std::endl;
   }




dat<<std::endl;
dat<<*ni<<std::endl;

   for(int i=0;i<*ni;i++)
     {
      for(int j=0;j<d;j++)
         {
          dat<<I[i][j]<<"     ";
         } 
       dat<<std::endl;
     }       
  
dat<<std::endl;
dat<<m<<std::endl;

for(int i=0;i<m;i++)
     {
      for(int j=0;j<3;j++)
         {
          dat<<G[i][j]<<"     ";
         } 
       dat<<std::endl;
     }       

dat<<std::endl;
dat<<eta<<std::endl;
dat<<eta1<<std::endl;
dat<<r<<std::endl;


dat<<std::endl;
dat<<nkmin<<std::endl;

dat<<std::endl;
for(int i=0;i<d;i++)
  {
   dat<<Cq[i][0]<<"     "<<Cq[i][1]<<std::endl;
  }

dat.close();

}

void recupere_data( const char* data, int d, int n, int m,  int* nld, std::vector<double*>* P,std::vector<double*>* H, std::vector<double*>* N, std::vector<int*>*  V, std::vector<int>* S, std::vector<double*>* Ikmin, int* ni, int** I, double** G, double* v, int* nkm, int** Cq)
{

    (void)(n);
int s,a,m2;
double rien; 

double* vp = new double[d+2];
double* vh = new double[2];
double* vn = new double[2];
int* vv = new int[d];

std::ifstream dat(data,std::ios::in);
dat>>*nld;

for(int i=0;i<*nld;i++)
   {
    for(int j=0;j<d+2;j++)
      dat>>std::setprecision(20)>>vp[j];
    (*P).push_back(vp);
    vp = new double[d+2];
   }

dat>>s;

for(int i=0;i<s;i++)
   {
    dat>>std::setprecision(20)>>vh[0];
    dat>>std::setprecision(20)>>vh[1];
    (*H).push_back(vh);
    vh = new double[2];
   }

dat>>s;

for(int i=0;i<s;i++)
   {
    dat>>std::setprecision(20)>>vn[0];
    dat>>std::setprecision(20)>>vn[1];
    (*N).push_back(vn);
    vn = new double[2];
   }


dat>>s;

for(int i=0;i<s;i++)
   {
    for(int j=0;j<d;j++)
      dat>>std::setprecision(20)>>vv[j];
    (*V).push_back(vv);
    vv = new int[d];
   }

dat>>s;

for(int i=0;i<s;i++)
  {
   dat>>std::setprecision(20)>>a;
   (*S).push_back(a);
  }

dat>>s;

for(int i=0;i<s;i++)
   {
    dat>>std::setprecision(20)>>vh[0];
    dat>>std::setprecision(20)>>vh[1];
    (*Ikmin).push_back(vh);
    vh = new double[2];
   }




dat>>*ni;

   for(int i=0;i<*ni;i++)
     {
      for(int j=0;j<d;j++)
         {
          dat>>I[i][j];
         } 
     }       
  

dat>>m2;
if(m2<=m)
{  
  for(int i=0;i<m2;i++)
     {
      for(int j=0;j<3;j++)
         {
          dat>>G[i][j];
         } 
     }
  if(m>m2)
  {
    for(int i=m2;i<m;i++)
    {
        G[i][0] = 0;
        G[i][1] = -1;
        G[i][2] = -1;
    }
  }
}
else
{
  for(int i=0;i<m;i++)
     {
      for(int j=0;j<3;j++)
         {
          dat>>G[i][j];
         } 
     } 
   for(int i=m;i<m2;i++)
     {
      for(int j=0;j<3;j++)
         {
          dat>>rien;
         } 
     }  
}


dat>>v[0];
dat>>v[1];
dat>>v[2];
dat>>*nkm;

for(int i=0;i<d;i++)
  {
   dat>>Cq[i][0];
   dat>>Cq[i][1];
  }

dat.close();

delete[] vp;
delete[] vh;
delete[] vn;
delete[] vv;


}



// double fct_integ_adaptatif(double (*f)(double*),int d,int l,int m,double tol,char fich_quad[20],char fich_ind[20],int* ni)
// {
// int n,nl,nld,p,nk,a,aa,b;
// double r,gi,delta_1,delta_j,coef,eta,s;
// n = int(pow(2.0,d+0.0))-1;
// nl = int(pow(2.0,l+0.0))-1; // quadrature de fejer
// //if(l!=1)
// //  nl = int(pow(2.0,l-1.0)) +1;  //quadrature de clenshaw curtis
// //else nl = 1;
// 
// nld = 0;
// double* K = new double[d];
// int* indi = new int[d];
// int* indj = new int[d];
// int** I = new int*[m];
// double** G = new double*[m];
// double** Delta = new double*[nl];
// int** J = new int*[n];
// 
// for(int i=0;i<m;i++)
//   {
//    I[i] = new int[d];
//    G[i] = new double[3];
//   } 
//   
// for(int i=0;i<nl;i++)
//    Delta[i] = new double[l+1];  
// 
// for(int i=0;i<n;i++)
//   {
//    J[i] = new int[d]; 
//    for(int j=0;j<d;j++)
//     J[i][j] = 0;
//   }  
//   
// indices(J,d);
// 
// 
// vector<double*> P;
// double* vp = new double[d+2];
// vector<double*> H;
// double* vh = new double[2];
// vector<double*> N;
// double* vn = new double[2];
// 
// P.reserve(100000);H.reserve(100000);N.reserve(100000);
// 
// for(int i=0;i<d;i++)
//    indi[i] = 1; 
//  
//  for(int i=0;i<m;i++)
//    {
//     G[i][0] = 0;
//     G[i][1] = -1;
//     G[i][2] = -1;
//    }
//        
//  for(int i=0;i<d;i++)
//    { 
//     I[0][i] = indi[i];
//     vp[i] = 0.0; 
//    }  
//  *ni = 1;  
//  
//  r = f(vp);
//  delta_1 = r;  
// 
//  
//  //--------calcul de Delta ----------------------------
// 
// double** q = new double*[2];
// q[0] = new double[nl]; 
// q[1] = new double[nl];
// 
// for(int i=0;i<nl;i++)
//   {
//     for(int j=0;j<l+1;j++)
//        Delta[i][j] = 0;
//   }     
// 
// for(int k=1;k<l;k++)
//   {
//   
//    fejer2(q[0],q[1],k);
//    
//    for(int r=0;r<int(pow(2.0,k+0.0))-1;r++)
//      {
//       Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] = Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] + 0.5*q[1][r] ;
//       
//       Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1]= Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1] - 0.5*q[1][r] ;
//      }
//      
//     /* clenshaw_curtis(q[0],q[1],k);
//    
//    for(int r=0;r<int(pow(2.0,k-1.0))+1;r++)
//      {
//       Delta[int(pow(2.0,l-k+0.0))*r][k] = Delta[int(pow(2.0,l-k+0.0))*r][k] + 0.5*q[1][r] ;
//       
//       Delta[int(pow(2.0,l-k+0.0))*r][k+1]= Delta[int(pow(2.0,l-k+0.0))*r][k+1] - 0.5*q[1][r] ;
//      }*/
//      
//   }
//   
//   //clenshaw_curtis(q[0],q[1],l);
//   fejer2(q[0],q[1],l);  
//   for(int r=0;r<nl;r++)
//     {
//      Delta[r][l] = Delta[r][l] + 0.5*q[1][r];
//      Delta[r][0] = q[0][r];
//     }
//   
// //--------fin du calcul de Delta -----------------------
// 
// 
// //---calcul du premier terme (1,1,...,1)---------------
// 
// make_heap(G,G+m,inf2);
// 
// vp[d] = r;//delta_1;
// vp[d+1] = 1.0;
// for(int i=0;i<d;i++)  //fejer
//    K[i] = int(pow(2.0,l-1.0))-1;
// //for(int i=0;i<d;i++)  // clenshaw curtis
// //   K[i] = 0;//int(pow(2.0,l-1.0));   
//    
// vh[0] = h(K,d,nl);
// vh[1] = 0;
// P.push_back(vp);
// H.push_back(vh);
// vp = new double[d+2];
// vh = new double[2];
// 
// for(int i=0;i<d;i++)  
//    K[i] = 1;
// vn[0] = h(K,d,l);
// vn[1] = 0;
// N.push_back(vn); 
// vn = new double[2];
//    
// nld = 1;
// 
// //----fin du calcul du premier terme ----------  
// 
// //--calcul de la premiere �tape-----------------------------
// /*int** A = new int*[m];
// for(int i=0;i<m;i++)
//    A[i] = new int[d]*/;
// int* S = new int[n];
// 
// eta = 0.0;
// 
// for(int i=0;i<n;i++) 
//    { 
//      for(int j=0;j<d;j++)
//         {   
//          indi[j] = J[i][j] + 1;
// 	 I[*ni][j] = indi[j];
// 	 K[j] = indi[j];
// 	} 
//      vn[0] = h(K,d,l);
//      vn[1] = *ni;
//      N.insert(lower_bound(N.begin(),N.end(),vn,inf2),vn);  
//      vn = new double[2];
//      
//      delta_j = 0.0;
//      nk=1;
//      for(int j=0;j<d;j++) //fejer
//         {
// 	 nk = nk * (int(pow(2.0,indi[j]+0.0))-1);
// 	}
//     /* for(int i=0;i<d;i++)  // clenshaw curtis
//         {
//          if(indj[i]>1)
//            nk = nk*(int(pow(2.0,indj[i]-1.0))+1); 
//          } */ 
//      for(int j=0;j<nk;j++)
// 	{       
// 	 coef = 1;
// 	 p = nk;
// 	 for(int kk=0;kk<d;kk++)
// 	    {
//              a = indi[kk];
// 	     b = int(pow(2.0,a+0.0))-1; //fejer
// 	     /*if(a>1)  // clenshaw curtis
// 	     b = int(pow(2.0,a-1.0))+1;
// 	     else b=1;*/
// 	     p = p/b;
// 	     aa = int(pow(2.0,l-a+0.0))*((j/p)%b +1)-1; // fejer
// 	     //aa = int(pow(2.0,l-a+0.0))*((j/p)%b); // clenshaw curtis
// 	     K[kk] = aa; 
// 	     coef = coef* Delta[aa][a]; 
// 	     vp[kk] = Delta[aa][0];
// 	    }
// 	  vh[0] = h(K,d,nl);
// 	  vh[1] = nld;
// 	  if(binary_search(H.begin(),H.end(),vh,inf2) == false)
// 	    {
// 	     s = f(vp);
// 	     vp[d] = s;
// 	     vp[d+1] = coef;
// 	     P.insert(P.end(),vp);
// 	     H.insert(lower_bound(H.begin(),H.end(),vh,inf2),vh);  
// 	     vh = new double[2];
//              delta_j = delta_j + coef*s;
// 	     vp = new double[d+2];
// 	     nld = nld+1;  
// 	    } 
// 	  else{
// 	    s = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d];
// 	    P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] + coef;
//             delta_j = delta_j + coef*s; 
// 	       }  
// 	} 
// 	
//     
//      r = r + delta_j;
//      *ni = *ni + 1;
//      gi = fabs(delta_j);
//      
//      if(gi>tol) 
//       {
//        S[i] = 1;
//        eta = eta + gi;
//        if(G[m-1][0]==0){ 
//          G[m-1][2] = i;  
// 	 G[m-1][1] = *ni-1;   
// 	 G[m-1][0] = gi; 
//          push_heap(G,G+m,inf2);
//         }
//        else{
// 	  sort_heap(G,G+m,inf2);
// 	  make_heap(G,G+m,inf2);
// 	  G[m-1][2] = i;
// 	  G[m-1][1] = *ni-1;   
// 	  G[m-1][0] = gi; 
//           push_heap(G,G+m,inf2);
//          }   
//       } 
//      else S[i] = 0;
//    } 
//    
//    
// //-----fin de la premi�re �tape---------------------
// 
// //-----d�but de la boucle principale----------------  
// int nindi,u;
// 
//  while( eta>tol && *ni<m ) 
//    {
//     nindi = int(G[0][1]);
//     for(int k=0;k<d;k++)
//       {
//       indi[k] = I[nindi][k];
//       if(indi[k]==l) u=-1;
//       }
//     if(u==-1)
//      {
//       cout<<"arret du programme "<<endl;
//       break;
//      }  
//     
//     eta = eta - G[0][0];
//     u = int(G[0][2]);
//     pop_heap(G,G+m,inf2);
//     G[m-1][0] = 0;
//     G[m-1][1] = -1;
//     G[m-1][2] = -1;      
//     
//    
//    
//     for(int k=0;k<d;k++)
//       {
//        if(J[u][k]==1)
//          {
//           for(int j=0;j<d;j++)
// 	    {
//              indj[j] = indi[j];
// 	     K[j] = indi[j];
// 	    }
//           indj[k] = indj[k] +1;
// 	  K[k] = indj[k];
// 	  vn[0] = h(K,d,l) ;
// 	  vn[1] = *ni;
// 	  if(binary_search(N.begin(),N.end(),vn,inf2) == false)
// 	    {
// 	     N.insert(lower_bound(N.begin(),N.end(),vn,inf2),vn);
// 	     for(int i=0;i<d;i++)
// 	        I[*ni][i] = indj[i];
//              
// 	    delta_j = 0.0;
//             nk=1;
//             for(int j=0;j<d;j++) //fejer
//               {
// 	       nk = nk * (int(pow(2.0,indj[j]+0.0))-1);
// 	      }
//          
//             for(int j=0;j<nk;j++)
// 	      {       
// 	       coef = 1;
// 	       p = nk;
// 	       for(int kk=0;kk<d;kk++)
// 	         {
//                   a = indj[kk];
// 	          b = int(pow(2.0,a+0.0))-1; //fejer
// 	          p = p/b;
// 	          aa = int(pow(2.0,l-a+0.0))*((j/p)%b +1)-1; // fejer
// 	          K[kk] = aa; 
// 	          coef = coef* Delta[aa][a]; 
// 	          vp[kk] = Delta[aa][0];
// 	         }
// 	       vh[0] = h(K,d,nl);
// 	       vh[1] = nld;
// 	       if(binary_search(H.begin(),H.end(),vh,inf2) == false)
// 	         {
// 	          s = f(vp);
// 	          vp[d] = s;
// 		  vp[d+1] = coef;
// 	          P.insert(P.end(),vp);
// 	          H.insert(lower_bound(H.begin(),H.end(),vh,inf2),vh);  
// 	          vh = new double[2];
//                   delta_j = delta_j + coef*s;
// 	          vp = new double[d+2];
// 	          nld = nld+1;  
// 	         } 
// 	       else{
// 	          s = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d];
// 		  P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] + coef;
//                   delta_j = delta_j + coef*s; 
// 	         }  
// 	      } 
// 	
//           
//                r = r + delta_j;
//                *ni = *ni + 1;
// 	   gi = fabs(delta_j);  
//      
//             if(gi>tol) 
//               {
//                eta = eta + gi;
//                if(G[m-1][0]==0){ 
//                  G[m-1][2] = u;  
// 	         G[m-1][1] = *ni-1;   
// 	         G[m-1][0] = gi; 
//                  push_heap(G,G+m,inf2);
//                 }
//                else{
// 	          sort_heap(G,G+m,inf2);
// 	          make_heap(G,G+m,inf2);
// 	          G[m-1][2] = u;
// 	          G[m-1][1] = *ni-1;   
// 	          G[m-1][0] = gi; 
//                   push_heap(G,G+m,inf2);
//                  }   
//                } 
//              vn = new double[2];
// 	     
// 	    }   
//          }
//       }      
//    } 
//    
// //----fin de la boucle principale------------------
// 
//    //PC psi(d,7,'l');
//    //psi.affiche_npt();
// 
// 
//    /*char nomfich[11] = "indice.dat";
//    ofstream indice (nomfich,ios::out); */
//  
//    ofstream indice (fich_ind,ios::out);
//    ofstream quad (fich_quad,ios::out);
//  
// 
//    for(int i=0;i<*ni;i++)
//      {
//       for(int j=0;j<d;j++)
//          {
//           indice<<I[i][j]<<"   ";
//          } 
//        indice<<endl;  
//      }   
//    indice.close();
//     
//   quad<<nld<<endl; 
//   for(int i=0;i<nld;i++)
//      {
//       for(int j=0;j<d+2;j++)
//          {
//           quad<<setprecision(12)<<P[i][j]<<"   ";
//          }  
//        quad<<endl;  
//      }        
//    quad.close(); 
// 
//  //cout<<ni<<endl;
//  //cout<<nld<<endl;  
// //cout<<setprecision(12)<<r<<endl;       
// return r; 
//      
// }
// //-------fin -----------------------------
// 

// double fct_integ_adaptatif2(double (*f)(double*),int d,int l,int m,double tol,char fich_quad[20],char fich_ind[20],int* ni)//modifier la partie de compl�ment(fausse)
// {
// int n,nl,nld,p,nk,a,aa,b;
// double r,gi,delta_1,delta_j,coef,eta,s;
// n = int(pow(2.0,d+0.0))-1;
// nl = int(pow(2.0,l+0.0))-1; // quadrature de fejer
// //if(l!=1)
// //  nl = int(pow(2.0,l-1.0)) +1;  //quadrature de clenshaw curtis
// //else nl = 1;
// 
// nld = 0;
// double* K = new double[d];
// int* indi = new int[d];
// int* indj = new int[d];
// int** I = new int*[m];
// double** G = new double*[m];
// double** Delta = new double*[nl];
// int** J = new int*[n];
// 
// for(int i=0;i<m;i++)
//   {
//    I[i] = new int[d+1];
//    for(int j=0;j<d+1;j++)
//       I[i][j]=0;
//    G[i] = new double[3];
//   } 
// 
// for(int i=0;i<nl;i++)
//    Delta[i] = new double[l+1];  
// 
// for(int i=0;i<n;i++)
//   {
//    J[i] = new int[d]; 
//    for(int j=0;j<d;j++)
//     J[i][j] = 0;
//   }  
//   
// indices(J,d);
// 
// /*for(int i=0;i<n;i++)
//    {
//     for(int j=0;j<d;j++)
//       cout<<J[i][j]<<"  ";
//       cout<<endl;
//    } 
// cout<<endl;
// cout<<endl;*/
// 
// vector<double*> P;
// double* vp = new double[d+2];
// vector<double*> H;
// double* vh = new double[2];
// vector<double*> N;
// double* vn = new double[2];
// 
// P.reserve(100000);H.reserve(100000);N.reserve(100000);
// 
// for(int i=0;i<d;i++)
//    indi[i] = 1; 
//  
//  for(int i=0;i<m;i++)
//    {
//     G[i][0] = 0;
//     G[i][1] = -1;
//     G[i][2] = -1;
//    }
//        
//  for(int i=0;i<d;i++)
//    { 
//     I[0][i] = indi[i];
//     vp[i] = 0.0; 
//    }
// I[0][d] = -1;
//  *ni = 1;  
//  
//  r = f(vp);
//  delta_1 = r;  
// 
//  
//  //--------calcul de Delta ----------------------------
// 
// double** q = new double*[2];
// q[0] = new double[nl]; 
// q[1] = new double[nl];
// 
// for(int i=0;i<nl;i++)
//   {
//     for(int j=0;j<l+1;j++)
//        Delta[i][j] = 0;
//   }     
// 
// for(int k=1;k<l;k++)
//   {
//   
//    fejer2(q[0],q[1],k);
//    
//    for(int r=0;r<int(pow(2.0,k+0.0))-1;r++)
//      {
//       Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] = Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] + 0.5*q[1][r] ;
//       
//       Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1]= Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1] - 0.5*q[1][r] ;
//      }
//      
//     /* clenshaw_curtis(q[0],q[1],k);
//    
//    for(int r=0;r<int(pow(2.0,k-1.0))+1;r++)
//      {
//       Delta[int(pow(2.0,l-k+0.0))*r][k] = Delta[int(pow(2.0,l-k+0.0))*r][k] + 0.5*q[1][r] ;
//       
//       Delta[int(pow(2.0,l-k+0.0))*r][k+1]= Delta[int(pow(2.0,l-k+0.0))*r][k+1] - 0.5*q[1][r] ;
//      }*/
//      
//   }
//   
//   //clenshaw_curtis(q[0],q[1],l);
//   fejer2(q[0],q[1],l);  
//   for(int r=0;r<nl;r++)
//     {
//      Delta[r][l] = Delta[r][l] + 0.5*q[1][r];
//      Delta[r][0] = q[0][r];
//     }
//   
// //--------fin du calcul de Delta -----------------------
// 

//---calcul du premier terme (1,1,...,1)---------------

// make_heap(G,G+m,inf2);
// 
// vp[d] = r;//delta_1;
// vp[d+1] = 1.0;
// for(int i=0;i<d;i++)  //fejer
//    K[i] = int(pow(2.0,l-1.0))-1;
// //for(int i=0;i<d;i++)  // clenshaw curtis
// //   K[i] = 0;//int(pow(2.0,l-1.0));   
//    
// vh[0] = h(K,d,nl);
// vh[1] = 0;
// P.push_back(vp);
// H.push_back(vh);
// vp = new double[d+2];
// vh = new double[2];
// 
// for(int i=0;i<d;i++)  
//    K[i] = 1;
// vn[0] = h(K,d,l);
// vn[1] = 0;
// N.push_back(vn); 
// vn = new double[2];
//    
// nld = 1;make_heap(G,G+m,inf2);

// vp[d] = r;//delta_1;
// vp[d+1] = 1.0;
// for(int i=0;i<d;i++)  //fejer
//    K[i] = int(pow(2.0,l-1.0))-1;
// //for(int i=0;i<d;i++)  // clenshaw curtis
// //   K[i] = 0;//int(pow(2.0,l-1.0));   
//    
// vh[0] = h(K,d,nl);
// vh[1] = 0;
// P.push_back(vp);
// H.push_back(vh);
// vp = new double[d+2];
// vh = new double[2];
// 
// for(int i=0;i<d;i++)  
//    K[i] = 1;
// vn[0] = h(K,d,l);
// vn[1] = 0;
// N.push_back(vn); 
// vn = new double[2];
//    
// nld = 1;


//----fin du calcul du premier terme ----------  

//--calcul de la premiere �tape-----------------------------
/*int** A = new int*[m];
for(int i=0;i<m;i++)
   A[i] = new int[d]*/;
// int* S = new int[n];   
// 
// eta = 0.0;
// 
// for(int i=0;i<n;i++) 
//    { 
//      for(int j=0;j<d;j++)
//         {   
//          indi[j] = J[i][j] + 1;
// 	 I[*ni][j] = indi[j];
// 	 K[j] = indi[j];
// 	}
//      I[*ni][d] = i; 
//      vn[0] = h(K,d,l);
//      vn[1] = *ni;
//      N.insert(lower_bound(N.begin(),N.end(),vn,inf2),vn);  
//      vn = new double[2];
//      
//      delta_j = 0.0;
//      nk=1;
//      for(int j=0;j<d;j++) //fejer
//         {
// 	 nk = nk * (int(pow(2.0,indi[j]+0.0))-1);
// 	}
//     /* for(int i=0;i<d;i++)  // clenshaw curtis
//         {
//          if(indj[i]>1)
//            nk = nk*(int(pow(2.0,indj[i]-1.0))+1); 
//          } */ 
//      for(int j=0;j<nk;j++)
// 	{       
// 	 coef = 1;
// 	 p = nk;
// 	 for(int kk=0;kk<d;kk++)
// 	    {
//              a = indi[kk];
// 	     b = int(pow(2.0,a+0.0))-1; //fejer
// 	     /*if(a>1)  // clenshaw curtis
// 	     b = int(pow(2.0,a-1.0))+1;
// 	     else b=1;*/
// 	     p = p/b;
// 	     aa = int(pow(2.0,l-a+0.0))*((j/p)%b +1)-1; // fejer
// 	     //aa = int(pow(2.0,l-a+0.0))*((j/p)%b); // clenshaw curtis
// 	     K[kk] = aa; 
// 	     coef = coef* Delta[aa][a]; 
// 	     vp[kk] = Delta[aa][0];
// 	    }
// 	  vh[0] = h(K,d,nl);
// 	  vh[1] = nld;
// 	  if(binary_search(H.begin(),H.end(),vh,inf2) == false)
// 	    {
// 	     s = f(vp);
// 	     vp[d] = s;
// 	     vp[d+1] = coef;
// 	     P.insert(P.end(),vp);
// 	     H.insert(lower_bound(H.begin(),H.end(),vh,inf2),vh);  
// 	     vh = new double[2];
//              delta_j = delta_j + coef*s;
// 	     vp = new double[d+2];
// 	     nld = nld+1;  
// 	    } 
// 	  else{
// 	    s = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d];
// 	    P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] + coef;
//             delta_j = delta_j + coef*s; 
// 	       }  
// 	} 
// 	
     /*for(int j=0;j<d;j++)
        cout<<indi[j]<<"   ";
     cout<<endl;
     cout<<delta_j<<endl;*/
//      r = r + delta_j;
//      *ni = *ni + 1;
//      gi = fabs(delta_j);
//      
//      if(gi>tol) 
//       {
//        S[i] = 1;
//        eta = eta + gi;
//        if(G[m-1][0]==0){ 
//          G[m-1][2] = i;  
// 	 G[m-1][1] = *ni-1;   
// 	 G[m-1][0] = gi; 
//          push_heap(G,G+m,inf2);
//         }
//        else{
// 	  sort_heap(G,G+m,inf2);
// 	  make_heap(G,G+m,inf2);
// 	  G[m-1][2] = i;
// 	  G[m-1][1] = *ni-1;   
// 	  G[m-1][0] = gi; 
//           push_heap(G,G+m,inf2);
//          }   
//       } 
//      else S[i] = 0;
//    } 
   
   
//-----fin de la premi�re �tape---------------------

//-----d�but de la boucle principale----------------  
/*int nindi,u;

 while( eta>tol && *ni<m ) 
   {
    nindi = int(G[0][1]);
    for(int k=0;k<d;k++)
      {
      indi[k] = I[nindi][k];
      if(indi[k]==l) u=-1;
      }
    if(u==-1)
     {
      cout<<"arret du programme "<<endl;
      break;
     }  
    
    eta = eta - G[0][0];
    u = int(G[0][2]);
    pop_heap(G,G+m,inf2);
    G[m-1][0] = 0;
    G[m-1][1] = -1;
    G[m-1][2] = -1;      
    
   
   
    for(int k=0;k<d;k++)
      {
       if(J[u][k]==1)
         {
          for(int j=0;j<d;j++)
	    {
             indj[j] = indi[j];
	     K[j] = indi[j];
	    }
          indj[k] = indj[k] +1;
	  K[k] = indj[k];
	  vn[0] = h(K,d,l) ;
	  vn[1] = *ni;
	  if(binary_search(N.begin(),N.end(),vn,inf2) == false)
	    {
	     N.insert(lower_bound(N.begin(),N.end(),vn,inf2),vn);
	     for(int i=0;i<d;i++)
	        I[*ni][i] = indj[i];
             I[*ni][d] = I[nindi][d];
	    delta_j = 0.0;
            nk=1;
            for(int j=0;j<d;j++) //fejer
              {
	       nk = nk * (int(pow(2.0,indj[j]+0.0))-1);
	      }
         
            for(int j=0;j<nk;j++)
	      {       
	       coef = 1;
	       p = nk;
	       for(int kk=0;kk<d;kk++)
	         {
                  a = indj[kk];
	          b = int(pow(2.0,a+0.0))-1; //fejer  
		  p = p/b;
	          aa = int(pow(2.0,l-a+0.0))*((j/p)%b +1)-1; // fejer
	          K[kk] = aa; 
	          coef = coef* Delta[aa][a]; 
	          vp[kk] = Delta[aa][0];
	         }
	       vh[0] = h(K,d,nl);
	       vh[1] = nld;
	       if(binary_search(H.begin(),H.end(),vh,inf2) == false)
	         {
	          s = f(vp);
	          vp[d] = s;
		  vp[d+1] = coef;
	          P.insert(P.end(),vp);
	          H.insert(lower_bound(H.begin(),H.end(),vh,inf2),vh);    
		  vh = new double[2];
                  delta_j = delta_j + coef*s;
	          vp = new double[d+2];
	          nld = nld+1;  
	         } 
	       else{
	          s = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d];
		  P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] + coef;
                  delta_j = delta_j + coef*s; 
	         }  
	      } */
	
           /* for(int j=0;j<d;j++)
               cout<<indj[j]<<"   ";
               cout<<endl;
               cout<<delta_j<<endl;*/
//                r = r + delta_j;
//                *ni = *ni + 1;
// 	   gi = fabs(delta_j);  
//             if(gi>tol) 
//               {
//                eta = eta + gi;
//                if(G[m-1][0]==0){ 
//                  G[m-1][2] = u;  
// 	         G[m-1][1] = *ni-1;   
// 	         G[m-1][0] = gi; 
//                  push_heap(G,G+m,inf2);
//                 }
//                else{
// 	          sort_heap(G,G+m,inf2);
// 	          make_heap(G,G+m,inf2);
// 	          G[m-1][2] = u;
// 	          G[m-1][1] = *ni-1;   
// 	          G[m-1][0] = gi; 
//                   push_heap(G,G+m,inf2);
//                  }   
//                } 
//              vn = new double[2];
// 	     
// 	    }   
//          }
//       }      
//    } 
//    
//----fin de la boucle principale------------------
 
//---compl�ment----faux � changer  --------------------------------

// int* X = new int[d]; 
// int it,nkk;
// vector<double*>::iterator iv;
// 
// 
// for(int i=0;i<n-1;i++)
//   {
//    if(S[i]==0)
//     {
//      nkk = 0;
//      for(int kk=0;kk<d;kk++)
// 	  {
// 	   if(J[i][kk]==1) 
// 	    {
// 	     X[nkk] = kk;
// 	     nkk = nkk +1;
// 	    } 
// 	  }
//      for(int j=i+1;j<n-1;j++)
//        {
//         if(S[j]==1)
// 	 {
//           u=1;
//           for(int k=0;k<nkk;k++)
// 	    {
// 	     if(J[j][X[k]]==0) 
// 	      {
// 	       u = 0;
// 	       break;
// 	      } 
// 	    }
// 	  if(u==1)
// 	   {
// 	    /*for(int k=0;k<d;k++)
// 	      {
// 	       K[k] = 1;
// 	       indj[k] = 1; 
// 	      }*/
// 	    it = *ni;  
// 	    for(int k=n+1;k<it;k++)
// 	      {
// 	       if(I[k][d]==j)
// 	        {
// 		for(int t=0;t<d;t++)
// 	          {
// 	           K[t] = 1;
// 	           indj[t] = 1; 
// 	          }
// 	         for(int t=0;t<nkk;t++)
// 	           {
// 		    indj[X[t]] = I[k][X[t]];
// 	            K[X[t]] = I[k][X[t]];
// 	           }
// 		 vn[0] = h(K,d,l) ;
// 	         vn[1] = *ni;
// 
// 		 if(binary_search(N.begin(),N.end(),vn,inf2)==false)
// 	          {
// 	           iv  = lower_bound(N.begin(),N.end(),vn,inf2);
// 		   N.insert(iv,vn);  
//                    vn = new double[2];
// 
// 	           for(int ii=0;ii<d;ii++)
// 	              I[*ni][ii] = indj[ii]; 
//                    I[*ni][d] = I[k][d];
// 	           delta_j = 0.0;
//                    nk=1;
//                    for(int jj=0;jj<d;jj++) //fejer
//                      {
// 	              nk = nk * (int(pow(2.0,indj[jj]+0.0))-1);
// 	             }
//                    for(int jj=0;jj<nk;jj++)
// 	             {     
// 	              coef = 1;
// 	              p = nk;
// 	              for(int kk=0;kk<d;kk++)
// 	                {
//                          a = indj[kk];
// 	                 b = int(pow(2.0,a+0.0))-1; //fejer
// 	                 vn[0] =    p = p/b;
// 	                 aa = int(pow(2.0,l-a+0.0))*((jj/p)%b +1)-1; // fejer
// 	                 K[kk] = aa; 
// 	                 coef = coef* Delta[aa][a]; 
// 	                 vp[kk] = Delta[aa][0];
// 	                }
// 	              vh[0] = h(K,d,nl);
// 	              vh[1] = nld;
// 	                s = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d];
// 		        P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] = P[int(*(*(lower_bound(H.begin(),H.end(),vh,inf2))+1))][d+1] + coef;  
// 	             }  
//                    *ni = *ni + 1;
// 	           if(*ni > m) break;
// 	          }        
// 		} 
// 	      }   
// 	   }
// 	 }
// 	 if(*ni > m) break;   
//        }
//     } 
//     if(*ni > m) break;
//   }
// 

//------------------------------------------------------------
   //PC psi(d,7,'l');
   //psi.affiche_npt();


   /*char nomfich[11] = "indice.dat";
   ofstream indice (nomfich,ios::out); */
 
//    ofstream indice (fich_ind,ios::out);
//    ofstream quad (fich_quad,ios::out);
//  
// 
//    for(int i=0;i<*ni;i++)
//      {
//       for(int j=0;j<d;j++)
//          {
//           //cout<<I[i][j]<<"   ";
//           indice<<I[i][j]<<"   ";
//          } 
//        //cout<<endl; 
//        indice<<endl;  
//      }   
//    //cout<<endl;      
//    indice.close();
//    //cout<<endl;
//     
//   quad<<nld<<endl; 
//   for(int i=0;i<nld;i++)
//      {
//       for(int j=0;j<d+2;j++)
//          {
//           quad<<setprecision(12)<<P[i][j]<<"   ";
//          }  
//        quad<<endl;  
//      }        
//    quad.close(); 
// 
//  //cout<<ni<<endl;
//  //cout<<nld<<endl;  
// //cout<<setprecision(12)<<r<<endl;       
// return r; 
//      
// }


//--------------------------------------------

void indices3(int** L, int* A, int d, int p)
{
 int q;  
 for(int l=0;l<p;l++)
    {
     q = p;
     for(int i=0;i<d;i++)
        {
	 q = q/(A[i]-1);
	 L[l][i] = (l/q)%(A[i]-1)+2;
        }
    }
}


/*void indices(int** J, int d)
{
 int ind = 0;
 for(int p=1;p<=d;p++)
    {
     indices2(J,d,p,0,ind);
     ind = ind + comb(d,p);
    }
}  
 

void indices2(int** J, int d, int p, int i, int k)
{
 if(d>0 && p>0)
 {
 if(p>1 && d!=p)
   {
    for(int j=0;j<comb(d-1,p-1);j++)
       {
        J[k+j][i] = 1;
       }
    for(int j=comb(d-1,p-1);j<comb(d-1,p-1)+comb(d-1,p)-1;j++)
       {
        J[k+j][i] = 0;
       } 
    indices2(J,d-1,p-1,i+1,k);
    indices2(J,d-1,p,i+1,k+comb(d-1,p-1));
   }
 else
   {
    if(p==1)
      {
       for(int j=0;j<d;j++)
          J[k+j][i+j] = 1;
      }
    else
      {
       for(int j=0;j<d;j++)
          J[k][i+j] = 1;
      } 
   } 
 }    
}*/


void ens_adm(int d,int l,int* X,int** I,std::vector<double*>* NN,std::vector<double*>* HH,std::vector<double*>* PP,double** Delta,double** Delta_n,std::string loi,int* nld,std::vector<int>* OO)
{
 int* indi = new int[d];
 double* K = new double[d];
 double* KK = new double[d];
 double* vn = new double[2];
 double* vh = new double[2];
 bool vn_used = false;
 int ni = (*NN).size(); 
 int it,nk,a,aa,p,b,nl,itt;
 double coef;
 nl = int(pow(2.0,l+0.0))-1;
 int nRI = int(pow(2.0,RANK_INDICE+0.0))-1;// sort points constant
 for(int i=0;i<d;i++)
   {
    ni = (*NN).size();
    for(int j=0;j<d;j++)
     {
      indi[j] = X[j];
      K[j] = X[j];
     }
    indi[i] = indi[i]-1;
    K[i] = K[i] -1;
    if(indi[i]>0)
      {
//        vn[0] = h(K,d,l) ;
       vn[0] = h(K,d,RANK_INDICE) ;
       vn[1] = ni;
       if(binary_search((*NN).begin(),(*NN).end(),vn,inf2)==false)
         {
	  (*NN).insert(lower_bound((*NN).begin(),(*NN).end(),vn,inf2),vn);
	  vn = new double[2];
      vn_used = true;
	  it = 0;itt = 0;
	  for(int ii=0;ii<d;ii++)
	    {
	     I[ni][ii] = indi[ii];
	     if(indi[ii]>1) 
	      {
	       it =it +int(pow(2.0,ii+0.0));
	       itt = itt+1;
	      } 
	    }  
          I[ni][d] = it;
	  std::vector<int> vv;
	  p=0;
	  for(unsigned j=0;j<(*OO).size();j++)
	    {
	     if(it ==  I[(*OO)[j]][d] )
	       {
		  a = 0;b=0;
		  for(int jj=0;jj<d;jj++)
		    {
		     if(I[ni][jj]<I[(*OO)[j]][jj])
		       a = a+1;
		     if(I[ni][jj]>I[(*OO)[j]][jj])
		       b = b+1;  
		    }
		  if(a==itt)
		   {
		    p = 1;
		    break;
		   }
		  else
		   {
		    if(b == itt)
		      {
		        vv.push_back((*OO)[j]);
		        //cout<<" j  "<<(*OO)[j]<<"   "<<it<<endl;
		       //cout<<I[ni][0]<<"   "<< I[ni][1]<<"   "<<I[ni][2]<<"   "<<endl; 
		      }
		   }  
		   
	      }
	    }
	    if(p == 0)
	      (*OO).push_back(ni);//cout<<" ni = "<<ni<<endl;
	    for(unsigned j=0;j<vv.size();j++)
	      { 
	        for(unsigned jj=0;jj<(*OO).size();jj++)  
	          {
		   if(vv[j]==(*OO)[jj])
		     (*OO).erase((*OO).begin()+jj);
		  } 
	      } 
	      
	  nk=1;
            for(int j=0;j<d;j++) //fejer
              {
	       nk = nk * (int(pow(2.0,indi[j]+0.0))-1);
	      }
         
            for(int j=0;j<nk;j++)
	      {       
	       coef = 1;
	       p = nk;
	       for(int kk=0;kk<d;kk++)
	         {
                  a = indi[kk];
	          b = int(pow(2.0,a+0.0))-1; //fejer
	          p = p/b;
	          aa = int(pow(2.0,l-a+0.0))*((j/p)%b +1)-1; // fejer
	          KK[kk] = aa; 
                  if(loi[kk]=='u')
	            coef = coef* Delta[aa][a]; 
                  else
                    coef = coef* Delta_n[aa][a];
	         }
		 vh[0] = h(KK,d,nl);
// 	       vh[0] = h(KK,d,nRI);
	       vh[1] = *nld; 
	       (*PP)[int(*(*(lower_bound((*HH).begin(),(*HH).end(),vh,inf2))+1))][d+1] = (*PP)[int(*(*(lower_bound((*HH).begin(),(*HH).end(),vh,inf2))+1))][d+1] + coef;
	     } 
	 }
       ens_adm(d,l,indi,I,NN,HH,PP,Delta,Delta_n,loi,nld,OO);
      }  
   }
   
   //Clean
    delete[] indi;
    indi = NULL;
    delete[] K;
    K = NULL;
    delete[] KK;
    KK = NULL;
    delete[] vh;
    vh = NULL;
    
    delete[] vn;
    vn = NULL;
    
//     if(!vn_used)
//     {
//         delete[] vn;
//         vn = NULL;
//     }
   
}  



bool inf(double a, double b)
{return fabs(b)>fabs(a);}

bool inf1(double* a, double* b)
{return fabs(b[0])<fabs(a[0]);}

bool inf2(double* a, double* b)
{return fabs(b[0])>fabs(a[0]);}

bool inf3(double a[2], double b[2])
{return fabs(b[0])<fabs(a[0]);}

bool inff(double* a, double* b)
{return b[0]>a[0];}


double h(double* v,int d,int n)
{
 double r = 0.0;
 for(int i=0;i<d;i++)
    r = r + v[i]*pow(log(n+0.0),log(i+1.0));
return r;
} 

bool simple_search(int* ind, int** I, int m, int d)
{
    bool found = false;
    bool temp;
    for(int k=0;k<m;k++)
    {
	temp = true;
	for(int i=0;i<d;i++)
	{
	    if(I[k][i] != ind[i])
	    {
		temp = false;
		break;
	    }
	}
	if(temp)
	{
	   found = true;
	   break;
	}
    }
    
    return found;
}

bool simple_vector_search(int* ind, std::vector<int*> I, int d)
{
    bool found = false;
    bool temp;
    for(int k=0;k<(int)(I.size());k++)
    {
	temp = true;
	for(int i=0;i<d;i++)
	{
	    if(I[k][i] != ind[i])
	    {
		temp = false;
		break;
	    }
	}
	if(temp)
	{
	   found = true;
	   break;
	}
    }
    
    return found;
}


void calcul_delta_n( double** Delta, int l)//construit le tableau des delta unidimensionnels normale
{
int nl;
nl = int(pow(2.0,l+0.0))-1;

double** q = new double*[2];
q[0] = new double[nl]; 
q[1] = new double[nl];

for(int i=0;i<nl;i++)
  {
    for(int j=0;j<l+1;j++)
       Delta[i][j] = 0;
  }     

for(int k=1;k<l;k++)
  {
  
   quadrature_normale(q[0],q[1],k);
   
   for(int r=0;r<int(pow(2.0,k+0.0))-1;r++)
     {
      Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] = Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] + q[1][r] ;
      
      Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1]= Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1] - q[1][r] ;
     }
     
     
  }
  quadrature_normale(q[0],q[1],l);  
  for(int r=0;r<nl;r++)
    {
     Delta[r][l] = Delta[r][l] + q[1][r];
     Delta[r][0] = q[0][r];
    }
  
  // Clean
    delete[] q[0];
    q[0] = NULL;
    delete[] q[1];
    q[1] = NULL;
    delete[] q;
    q = NULL;

} 


void calcul_delta( double** Delta, int l)//construit le tableau des delta unidimensionnels uniforme
{
int nl;
nl = int(pow(2.0,l+0.0))-1; // quadrature de fejer

double** q = new double*[2];
q[0] = new double[nl]; 
q[1] = new double[nl];

for(int i=0;i<nl;i++)
  {
    for(int j=0;j<l+1;j++)
       Delta[i][j] = 0;
  }     

for(int k=1;k<l;k++)
  {
   fejer2(q[0],q[1],k);
   
  for(int r=0;r<int(pow(2.0,k+0.0))-1;r++)
     {
      Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] = Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k] + 0.5*q[1][r] ;
      
      Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1]= Delta[int(pow(2.0,l-k+0.0))*r+int(pow(2.0,l-k+0.0))-1][k+1] - 0.5*q[1][r] ;
     }
    
  }
  
  fejer2(q[0],q[1],l);  
  for(int r=0;r<nl;r++)
    {
     Delta[r][l] = Delta[r][l] + 0.5*q[1][r];
     Delta[r][0] = q[0][r];
    }


    // Clean
    delete[] q[0];
    q[0] = NULL;
    delete[] q[1];
    q[1] = NULL;
    delete[] q;
    q = NULL;
    
}

}

