//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTGPCostFunction.h
 \author Nicolas Gilardi <nicolas.gilardi@cea.fr>
 \date   $Date$
 
 \brief  Test suite for class URANIE::Modeler::TGPCostFunction and its children classes.
 


 */
#ifndef CPPUNITEST_TGPCOSTFUNCTION_H
#define CPPUNITEST_TGPCOSTFUNCTION_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

#include "TDataServer.h"

/*! \class TGPCostFunctionTest
 * \brief Unit tests for TGPCostFunctionTest.
 */

class TGPCostFunctionTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TGPCostFunctionTest);
    CPPUNIT_TEST(testTGPMLCostFunction);
    CPPUNIT_TEST(testTGPReMLCostFunction);
    CPPUNIT_TEST(testTGPLooCostFunction);
    CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TGPCostFunctionTest object.
     */
    TGPCostFunctionTest();

    /// Destructor.
    virtual ~TGPCostFunctionTest();

    URANIE::DataServer::TDataServer *tdsObs;

    void setUp();
    void tearDown();
    
    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    void testTGPMLCostFunction();
    void testTGPReMLCostFunction();
    void testTGPLooCostFunction();

    //@}
};
#endif  //CPPUNITEST_TGPCOSTFUNCTION_H

