//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_TBESTESTIMATE_H
#define CPPUNITEST_TBESTESTIMATE_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TBestEstimate.h"
#include "TDataServer.h"
#include "TAttribute.h"
#include "UExceptions.h"

class TBestEstimateTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TBestEstimateTest);

    CPPUNIT_TEST (testTBestEstimateEmptyConstructor);
    CPPUNIT_TEST (testTBestEstimateConstructorWithMatrices);
    CPPUNIT_TEST (testTBestEstimateRunBestEstimate);
    CPPUNIT_TEST (testTBestEstimateSetLog);
    
    CPPUNIT_TEST (throwExceptionTBestEstimateMethodNotYetImplemented);
    
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TBestEstimateTest();

    //! Default destructor
    virtual ~TBestEstimateTest();

    void setUp();
    void tearDown();

    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{ 
    void testTBestEstimateEmptyConstructor();
    void testTBestEstimateConstructorWithMatrices();
    void testTBestEstimateRunBestEstimate();
    void testTBestEstimateSetLog();
    
    void throwExceptionTBestEstimateMethodNotYetImplemented();
    
    //@}

private:
    URANIE::DataServer::TDataServer *_tds;
    URANIE::Optimizer::TBestEstimate * _tbe;
};

#endif  // CPPUNITEST_TVIZIR_H
