//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_T_H
#define CPPUNITEST_TMULTIGENSUMOFSQUARES_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TMultiGenSumOfSquares.h"
#include "TDataServer.h"
#include "TLauncher.h"
#include "TAttribute.h"
#include "UExceptions.h"
#include "TOutputFileDataServer.h"

class TMultiGenSumOfSquaresTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TMultiGenSumOfSquaresTest);
    
    CPPUNIT_TEST (testTMultiGenSumOfSquareaddObjective);
    CPPUNIT_TEST (testTMultiGenSumOfSquareClone);
    CPPUNIT_TEST (testTMultiGenSumOfSquareNDim);
    CPPUNIT_TEST (throwExceptionTMultiGenSumOfSquaresConstructorNull);
    CPPUNIT_TEST (throwExceptionTMultiGenSumOfSquareaddObjective);
    
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TMultiGenSumOfSquaresTest();

    //! Default destructor
    virtual ~TMultiGenSumOfSquaresTest();

    void setUp();
    void tearDown();

    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{ 
    void testTMultiGenSumOfSquareaddObjective();
    void testTMultiGenSumOfSquareClone();
    void testTMultiGenSumOfSquareNDim();
    void throwExceptionTMultiGenSumOfSquaresConstructorNull();
    void throwExceptionTMultiGenSumOfSquareaddObjective();
    //@}

private:
    URANIE::DataServer::TDataServer *tds;
    URANIE::Launcher::TCode *mycode;
    URANIE::Launcher::TOutputFileDataServer *fout;
    TString _workingTestPath;
};

#endif  // CPPUNITEST_TMULTIGENSUMOFSQUARES_H
