//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   bracket.c
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-07-13.11.40.29

 \brief 
 */

#include <stdlib.h>
#include <math.h>

#include "bracket.h"

#define COEF 1.6

int bracket_next(double *x1, double *fx1, double *x2, double *fx2)
{
    double tmp;

    if (*fx1 * *fx2 < 0)
        return 0;
    else
    {
        if (fabs(*fx1) < fabs(*fx2))
        {
            *x2 = *x1 + COEF * (*x1 - *x2);
        }
        else
        {
            tmp = *x2;
            *x2 = *x2 + COEF * (*x2 - *x1);
            *x1 = tmp;
            *fx1 = *fx2;
        }
        return 1;
    }
}

