//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;

#pragma link C++ namespace URANIE::Reoptimizer;

#pragma link C++ class URANIE::Reoptimizer::TOptimShare+;
#pragma link C++ class URANIE::Reoptimizer::TOptimFit+;
#pragma link C++ class URANIE::Reoptimizer::TMaximizeFit+;
#pragma link C++ class URANIE::Reoptimizer::TTargetFit+;
#pragma link C++ class URANIE::Reoptimizer::TLesserFit+;
#pragma link C++ class URANIE::Reoptimizer::TGreaterFit+;
#pragma link C++ class URANIE::Reoptimizer::TInsideFit+;
//#pragma link C++ global URANIE::Reoptimizer::kMaximizeFit;

#ifdef WITH_VIZIR
#pragma link C++ class URANIE::Reoptimizer::TVizirShare+;
#pragma link C++ class URANIE::Reoptimizer::TVizir2+;
#pragma link C++ class URANIE::Reoptimizer::TVizirIsland+;
#pragma link C++ class URANIE::Reoptimizer::TVizirSolver+;
#pragma link C++ class URANIE::Reoptimizer::TVizirSolverShare+;
#pragma link C++ class URANIE::Reoptimizer::TVizirGenetic+;
#pragma link C++ class URANIE::Reoptimizer::TVizirCrossover+;
#pragma link C++ class URANIE::Reoptimizer::TVizirSwarm+;
#pragma link C++ class URANIE::Reoptimizer::TVizirMovement+;
#pragma link C++ class URANIE::Reoptimizer::TVizirSimplex+;
#pragma link C++ class URANIE::Reoptimizer::TVizirAnts+;
#pragma link C++ class URANIE::Reoptimizer::TVizirPheromone+;
#pragma link C++ class URANIE::Reoptimizer::TVizirEval+;
#endif

#ifdef WITH_NLOPT
#pragma link C++ class URANIE::Reoptimizer::TNloptShare+;
#pragma link C++ class URANIE::Reoptimizer::TNloptSolver+;
#pragma link C++ class URANIE::Reoptimizer::TNlopt+;
#pragma link C++ class URANIE::Reoptimizer::TNloptGradient+;
#pragma link C++ class URANIE::Reoptimizer::TNloptCobyla+;
#pragma link C++ class URANIE::Reoptimizer::TNloptNelderMead+;
#pragma link C++ class URANIE::Reoptimizer::TNloptBobyqa+;
#pragma link C++ class URANIE::Reoptimizer::TNloptPraxis+;
#pragma link C++ class URANIE::Reoptimizer::TNloptSubplexe+;
#pragma link C++ class URANIE::Reoptimizer::TNloptMMA+;
#pragma link C++ class URANIE::Reoptimizer::TNloptSLSQP+;
#pragma link C++ class URANIE::Reoptimizer::TNloptLBFGS+;
#pragma link C++ class URANIE::Reoptimizer::TNloptNewton+;
#pragma link C++ class URANIE::Reoptimizer::TNloptVariableMetric+;
#endif

#pragma link C++ class URANIE::Reoptimizer::TCMAES+;
