//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TFitGetter.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-07-26.14.47.29

 \brief recuperation de sortie transformées
 */

#ifndef __FIT_GETTER__
#define __FIT_GETTER__

//ROOT
#include "Rtypes.h"
//#include "TNamed.h"

// Uranie
//#include "Relaucnher.h"

#include "TDataServer.h"
#include "TOptimFit.h"

namespace URANIE
{
namespace Reoptimizer
{

class TFitGetter: public TObject
{
protected:
    URANIE::DataServer::TAttribute *_ref, *_grad;
    TOptimFit *_fit;
    int _rang, _rangg;

public:
    class AttributeNotFound
    {
    };

    TFitGetter(URANIE::DataServer::TAttribute *ref, TObjArray *all,
            TOptimFit *fit);
    TFitGetter(URANIE::DataServer::TAttribute *ref, 
            URANIE::DataServer::TAttribute *grd, TObjArray *all,
            TOptimFit *fit);
    ~TFitGetter();

    double from(double *from);
    double from(int size, double *from, double *grad, double *to);
    double from(vector<URANIE::DataServer::UEntry*> *from);
    double from(int size, vector<URANIE::DataServer::UEntry*> *from,
        vector<URANIE::DataServer::UEntry*> *grad, double *to);
    double from(int size, vector<URANIE::DataServer::UEntry*> *from,
        double *to);

//ClassDef(URANIE::Reoptimizer::TFitGetter, ID_REOPTIMIZER)
};

}
} //namespace

#endif
