//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TNloptCobyla.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-03-20.16.05.46

 \brief Cobyla algorithm
 */

#ifndef __NLOPT_COBYLA__
#define __NLOPT_COBYLA__

#include "TNlopt.h"

namespace URANIE
{
namespace Reoptimizer
{

class TNloptCobyla: public TNloptSolver
{
public:
    TNloptCobyla();
    virtual ~TNloptCobyla();

    virtual nlopt_opt build(int, int, int, double, nlopt_opt*);

    ClassDef(URANIE::Reoptimizer::TNloptCobyla, ID_REOPTIMIZER)
};

class TNloptSLSQP: public TNloptSolver
{
public:
    TNloptSLSQP();
    virtual ~TNloptSLSQP();

    virtual nlopt_opt build(int, int, int, double, nlopt_opt*);

    ClassDef(URANIE::Reoptimizer::TNloptSLSQP, ID_REOPTIMIZER)
};

class TNloptMMA: public TNloptSolver
{
public:
    TNloptMMA();
    virtual ~TNloptMMA();

    virtual nlopt_opt build(int, int, int, double, nlopt_opt*);

    ClassDef(URANIE::Reoptimizer::TNloptMMA, ID_REOPTIMIZER)
};

}
} //namespace

#endif
