//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TVizirEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-01-11.15.51.21

 \brief utilisation des vzrfitnessbuild de vizir
 */

#ifndef __TVIZIREVAL__
#define __TVIZIREVAL__

//ROOT

//URANIE
#include "Reoptimizer.h"
#include "TStandardEval.h"

struct vzrfitnessbuild;
struct vzrfitness;

namespace URANIE
{
namespace Reoptimizer
{

class TVizirEval: public URANIE::Relauncher::TDoubleEval
{
protected:
    struct vzrfitnessbuild *_build;
    struct vzrfitness *_fit;

public:
    TVizirEval(struct vzrfitnessbuild *);
    virtual ~TVizirEval();
    void buildVizir();
    virtual URANIE::Relauncher::TEval *rebuild(int rank, Bool_t chef = kTRUE);
    virtual Int_t eval(Double_t *in, Double_t *out, int=0);
    
    ClassDef(URANIE::Reoptimizer::TVizirEval, ID_REOPTIMIZER)
};

}
} //namespace

#endif
