//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestUserFunctions.h
 \author Gilles Arnaud <gilles.arnaud@cea.fr>
 \date   2013-05-21 13:36:11

 \brief Interface for test functions
 */

#include <vector>

int frosenbrock(Double_t *in, Double_t *res);
//int frosenbrockG(Double_t *in, Double_t *res);
int frosenbrockGrad(vector<URANIE::DataServer::UEntry*> *in, 
    vector<URANIE::DataServer::UEntry *>  *out);
int frosenbrockVec(vector<URANIE::DataServer::UEntry*> *in, 
    vector<URANIE::DataServer::UEntry *>  *out);
int frosenbrockCummul(vector<URANIE::DataServer::UEntry*> *in, 
    vector<URANIE::DataServer::UEntry *>  *out);
int select(double *in, double *res);
int fselect(double *in, double *res);
int fselectd(vector<URANIE::DataServer::UEntry *> *in, 
    vector<URANIE::DataServer::UEntry*> *res);
int fselect_vec(vector<URANIE::DataServer::UEntry *> *in, 
    vector<URANIE::DataServer::UEntry*> *res);
int fselect_min(vector<URANIE::DataServer::UEntry *> *in, 
    vector<URANIE::DataServer::UEntry*> *res);
void add(double *in, double *out);

