/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2015-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   aco_query.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2015-08-24
 
 \brief  ants api
*/

#ifndef __ACO_QUERY__
#define __ACO_QUERY__

#include "ants/aco_struct.h"

#ifdef __cplusplus
extern "C" {
#endif

VZRLIB_EXPORT struct aco *aco_init(int nbin, int nbout, int nbcont, double prec);
VZRLIB_EXPORT int aco_prepare(struct aco *ret, int ant, int stop, int cyc);
VZRLIB_EXPORT int aco_build(struct aco *ret, int ant, int cyc, int stop);
VZRLIB_EXPORT int aco_resume(struct aco *self, int maxe, char *nfile);
VZRLIB_EXPORT void aco_run(struct aco *self);
VZRLIB_EXPORT void aco_start(struct aco *self);
VZRLIB_EXPORT void aco_wait(struct aco *self);
VZRLIB_EXPORT void aco_dump(struct aco *self, char *nfile);
VZRLIB_EXPORT int aco_running(struct aco *self);
VZRLIB_EXPORT void aco_dealloc(struct aco *self);

#ifdef __cplusplus
}
#endif

#endif
