/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2009-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   aco_struct.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2009-10-21
 
 \brief  ants specific structure
*/

#ifndef __ACO_STRUCT__
#define __ACO_STRUCT__

#include "vizir/vzrbase_api.h"

/* etat */
#define ACOIND_LOC  0
#define ACOIND_GLOB 1

struct aco;

/* protocole */
struct acorun {
    void *data;
    void (*prepare) (void*, struct aco*);
    int (*build) (void*, struct aco*, vzrgene_t*);
    void (*depose)(void*, struct aco *, vzrgene_t*, double);
    void (*dealloc) (struct acorun *);
};

/* structure */
struct aco {
    struct vzrbase base;
    /* read only value */
    double  evap, depo, pbest;
    double  tmin, tmax;
    struct acorun *work;
};

typedef struct aco aco_t;

#endif
