/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2008-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_naitre.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2008-03-19
 
 \brief  naissance des indivividus
*/


#ifndef __VZR_NAITRE__
#define __VZR_NAITRE__

#include "genetic/vzr_struct.h"

/* private */
int reevaluation(struct vizir*, struct vzrwork *);
int immigration(struct vizir*, struct vzrwork *);
void procreer(struct vizir*, struct vzrwork *);

/* public */
#ifdef __cplusplus
extern "C" {
#endif

VZRLIB_EXPORT struct vzrmating *vzrcouple_create(void);
VZRLIB_EXPORT struct vzrmating *vzrsexue_create(struct vizir *);

#ifdef __cplusplus
}
#endif

#endif

