/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2010-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_heap.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2010-04-14
 
 \brief  heapsort utilitaire
*/


#ifndef VZR_HEAP
#define VZR_HEAP

#include "vzr_config.h"

struct vzritem;

/* public */

#ifdef __cplusplus
extern "C" {
#endif

VZRLIB_EXPORT int vzr_rank_double(int size, int top, int *idx, double *val);
VZRLIB_EXPORT int vzr_rank_item(int size, int top, int *idx, struct vzritem *val );

#ifdef __cplusplus
}
#endif

#endif

