/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2010-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_pareto.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2010-02-17
 
 \brief  calcul du pseudo rang de pareto
*/


#ifndef __VZR_PARETO__
#define __VZR_PARETO__

#include "vzr_config.h"

/* etat de dominance */
#define EGAL 0
#define TWO_DOM  1
#define ONE_DOM 2
#define BOTH_DOM 3
#define DIFF 4
/* etat admissible */
#define ADMIS 0
#define REJET 1

/* predef */
struct vzrpop;

/* public */
#ifdef __cplusplus
extern "C" {
#endif

VZRLIB_EXPORT int mono_rank(struct vzrpop *, double*, double*);
VZRLIB_EXPORT int multi_rank(struct vzrpop *, double*, double*);
VZRLIB_EXPORT int mono_strict_rank(struct vzrpop *, double*, double*);
VZRLIB_EXPORT int mono_soft_rank(struct vzrpop *, double*, double*);
VZRLIB_EXPORT int multi_strict_rank(struct vzrpop *, double*, double*);
VZRLIB_EXPORT int multi_soft_rank(struct vzrpop *, double*, double*);
VZRLIB_EXPORT int admissible_rank(struct vzrpop *, double*, double*);

#ifdef __cplusplus
}
#endif

#endif

