/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2010-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzrcore_api.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2010-06-04
 
 \brief  main loop pour un vzrcore
*/

#ifndef __VZRCORE__
#define __VZRCORE__

#include "vizir/vzr_config.h"

/* protocole */
struct vzrcore {
    //struct vzralgo *algo;
    void *data;
    int (*get) (void *self, vzrgene_t *in);
    int (*put) (void *self, int good, vzrgene_t *in, double *out, void *dat);
    void (*subscribe)(void *self);
    void (*unsubscribe)(void *self);
    void (*dealloc)(struct vzrcore *);
};

/* private */
void vzrcore_run(struct vzrcore *core);
void vzrcore_start(struct vzrcore *self);

#endif
