/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2016-2024 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzrpop_util.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2016-04-21
 
 \brief  utilitaire sur la population
*/

#ifndef __VZRPOP_UTIL__
#define __VZRPOP_UTIL__

struct vzrpop;

struct voisin {
    short prof;
    int size;
    double *norm;
    int **ref;
    double **dist;
};

struct xplan {
    int dim;
    double **rot;
    double *plan;
};

void fill_voisin(struct voisin *self, char *fill, int i, int j, double dij);
void lastsort_voisin(struct voisin *self, int i);

void vzrpop_minmaxnorm(struct vzrpop *pop, int siz, double *norm);
void vzrpop_ideal_it(struct vzrpop *pop, int siz, double *ideal, double *norm);

void vzrpop_proche_voisin(struct vzrpop *pop, int siz, struct voisin *self);
void vzrpop_proche_voisin2(struct vzrpop *pop, int siz, struct voisin *self);
void vzrpop_proche_voisin3(struct vzrpop *pop, int siz, double *norm, struct voisin *self);
void vzrpop_proche_individu(struct vzrpop *pop, int siz, struct voisin *self);
void vzrpop_pareto_plan(struct vzrpop *pop, int size, struct xplan *self, double *norm);

#endif
