using namespace URANIE::DataServer;
using namespace URANIE::Relauncher;
using namespace URANIE::Reoptimizer;

/********** User Function *****************/

static double f1(double *param)
{
    double x = param[0] - 0.75;
    double y = param[1] - 0.25;

    return x * x + y * y;
}
static double f2(double *param)
{
    return param[0] * param[0] + param[1] * param[1];
}
#ifdef OLD
static double f3(double *paramt)
{
    double res;

    res = paramt[0]*paramt[0] + paramt[1]*paramt[1];
    return (res >= 1 )? 0 : 1-res;
}
static double f4(double *paramt)
{
    double res;

    res = paramt[0]*paramt[0] + paramt[1]*paramt[1];
    return (res <= 2.25)? 0 : res-2.25;
}
#endif

static void fselect(double *param, double *res)
{
#ifdef OLD
    res[0] = f3(param);
    res[1] = f4(param);
    res[2] = f1(param);
#else
    res[0] = f1(param);
    res[1] = f2(param);
#endif
}
/********** End Of User Function *****************/

void test_TVizirMonoConstraint()
{
    //////////////////////////////////////
    // Case of the Vizir Optimization
    //////////////////////////////////////
    TAttribute x1("x_{1}", -3.0, 3.0), x2("x_{2}", -3.0, 3.0);
    TAttribute cont("c_{1}"), obj("fc1");

    //tdsvzr.setLog();

    TCJitEval code(&fselect);
    code.addInput(&x1);
    code.addInput(&x2);
    code.addOutput(&obj);
    code.addOutput(&cont);

    TSequentialRun run(&code);
    run.startSlave();
    if (run.onMaster())
    {
        TDataServer tdsvzr("tdsvzr", "tds for vizir test");
        tdsvzr.addAttribute(&x1);
        tdsvzr.addAttribute(&x2);

        TVizirGenetic solv;
        //solv.setStrictConstraintPolicy();
        TInsideFit it(1.0, 2.25);
        TVizir2 vzr(&tdsvzr, &run, &solv);
        vzr.addConstraint(&cont, &it);
        vzr.addObjective(&obj);

        vzr.solverLoop();

        run.stopSlave();

        tdsvzr.exportData("_vizir_.dat");
        //tdsvzr.drawTufte("x_{2}:x_{1}");
        tdsvzr.getTuple()->Scan("*");
    }

}
