/*  _______________________________________________________________________

 DAKOTA: Design Analysis Kit for Optimization and Terascale Applications
 Copyright (c) 2001, Sandia National Laboratories.
 This software is distributed under the GNU General Public License.
 For more information, see the README file in the top Dakota directory.
 _______________________________________________________________________ */

//
//      File:         LHSVecMatUtil.H
//
//      Description:  Vector and Matrix Utilities
//***********************************************************************
#ifndef LHS_VEC_MAT_UTIL_H
#define LHS_VEC_MAT_UTIL_H

void nrerror(char errortext[]);
double **matrix(long int nrl, long int nrh, long int ncl, long int nch);
double **matrix(long int nrh, long int nch);
double *_vector(long int nl, long int nh);
double *_vector(long int nh);
long int *_ivector(long int nl, long int nh);
long int *_ivector(long int nh);
void Vsum(double *sum, double *vect1, double *vect2, long int N);
void Vdiff(double *diff, double *vect1, double *vect2, long int N);
void MTxV(double *answer, double **mtrx, long int N, long int M, double *vect,
        long int L);
double VTxV(double *vect1, double *vect2, long int L);
void invertmatrix(double **thematrix, long int n);

void ludcmp(double **a, long int n, long int *indx, double *d);
void lubksb(double **a, long int n, long int *indx, double b[]);
//void free_vector(double *v, long int nl, long int nh);
void free_vector(double *v);
void free_matrix(double **mat, long int n);

//  Functions from Numerical Recipes in C
int choldc(double **a, long int n, double p[]);
double gammln(double xx);
double ran2(int *idum);
double ran3(int *idum);

//  Random number generator from fortran version of LHS
double rnum1(int *idum);

//  Quicksort functions
void quicksort(double *a, long int F, long int L);
int partition(double *a, long int F, long int L);
void Swap(double *a, double *b);

#endif
