//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TSensitivityTest.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   fri oct 10 09:55:30 CEST 2008
 
 \brief Interface of class URANIE::Sensitivity::TSensitivityTest
 
 */
/**
 
 * @class URANIE::Sensitivity::TSensitivityTest
 *
 * @brief Description of the class TSensitivityTest.
 *
 * To be written by the developper.
 * \warning not yet implemented
 *
 */
#ifndef TSENSITIVITYTEST_H
#define TSENSITIVITYTEST_H
#include "TSensitivity.h"

#include <iostream>
using std::cout;
using std::endl;

namespace URANIE {
namespace Sensitivity {

class TSensitivityTest: public TSensitivity {
public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TSensitivityTest();
    //! Default constructor
    TSensitivityTest(URANIE::DataServer::TDataServer *tds,
            const char *varexpinput, const char *varexpoutput,
            Option_t * option = "");
    //! Default destructor
    virtual ~TSensitivityTest();
    //@}

    //---------------------------------------------
    /** @name Printing Log
     **/
    //@{
    virtual void printLog(Option_t *option = "");
    //@}

    ClassDef(URANIE::Sensitivity::TSensitivityTest, ID_SENSITIVITY)

    // Attributes
    private:
};

} // End Of namespace Sensitivity
} // End Of namespace URANIE
#endif
