//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   ClassName.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   DateName
 
 \brief Interface of classe URANIE::Sensitivity::ClassName
 
 */
/**
 
 * @class URANIE::Sensitivity::ClassName
 *
 * @brief Description of the class ClassName.
 *
 * To write by the developper.
 *
 */
#ifndef CLASSNAME_H
#define CLASSNAME_H
#include "TSensitivity.h"

namespace URANIE
{
namespace Sensitivity
{
class ClassName: public TSensitivity
{
private:
public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    ClassName();
    //! Default destructor
    virtual ~ClassName();
    //@}

    //---------------------------------------------
    /** @name Printing Log
     **/
    //@{
    virtual void printLog(Option_t *option = "");
    //@}

    ClassDef(URANIE::Sensitivity::ClassName, ID_SENSITIVITY)
    //Classe de
};

} // Fin du namespace Sensitivity
} // Fin du namespace URANIE
#endif
