////////////////////////////////////////////////////////////// 
// Copyright (C) 2013-2024 CEA/DES 
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_TSOBOLRANK_H
#define CPPUNITEST_TSOBOLRANK_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TSensitivity.h"
#include "TSobolRank.h"
#include "TDataServer.h"
#include "UExceptions.h"

class TSobolRankTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TSobolRankTest);

    CPPUNIT_TEST (testSobolRank);
    CPPUNIT_TEST (testIshigamiSobolRank);
    CPPUNIT_TEST (testIshigamiSobolRankWithDrawings);
    CPPUNIT_TEST (throwExceptionConstructorTooLongOutputFunctionFirst);
    CPPUNIT_TEST (throwExceptionConstructorTooLongOutputFunctionSecond);
    CPPUNIT_TEST (throwExceptionConstructorTooLongOutputCode);
    CPPUNIT_TEST (throwExceptionConstructorTooLongOutputRun);
    CPPUNIT_TEST (throwExceptionConstructorTooLongOutputFromData);
    CPPUNIT_TEST (throwExceptionTRegressionConstructorTdsNull);
    CPPUNIT_TEST (throwExceptionTRegressionConstructorFalseInput);
    CPPUNIT_TEST (throwExceptionTRegressionConstructorFalseOutput);
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TSobolRankTest();

    //! Default destructor
    virtual ~TSobolRankTest();

    void setUp();
    void tearDown();
    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{ 
    void testSobolRank();

    void testIshigamiSobolRank();
    void testIshigamiSobolRankWithDrawings();
    void throwExceptionConstructorTooLongOutputFunctionFirst();
    void throwExceptionConstructorTooLongOutputFunctionSecond();
    void throwExceptionConstructorTooLongOutputCode();
    void throwExceptionConstructorTooLongOutputRun();
    void throwExceptionConstructorTooLongOutputFromData();
    void throwExceptionTRegressionConstructorTdsNull();
    void throwExceptionTRegressionConstructorFalseInput();
    void throwExceptionTRegressionConstructorFalseOutput();
    //@}

private:
    URANIE::DataServer::TDataServer *tds1, *tds;
    URANIE::Sensitivity::TSobolRank *tsr;
    URANIE::Sensitivity::TSobolRank *tss1;
};

#endif  // CPPUNITEST_TSOBOLRANK_H