//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
/*!
 \file   TestTUncertModeler.cxx
 \author Maud Salvoldi (OCC/Areva group)
 \date   $Date$
 
 \brief  Test File of the class URANIE::DataServer::TUncertModeler
 
 Created: wen dec 21 16:59:24 2011
 
 */

#define DBL_PRECISION_COMPARE 1.e-12

#include <iostream>

//ROOT
#include "TString.h"

// URANIE
#include "TestTUncertModeler.h"

TUncertModelerTest::TUncertModelerTest() :
        _tds(NULL), _tks(NULL)
{

}
TUncertModelerTest::~TUncertModelerTest()
{

}
void TUncertModelerTest::setUp()
{
    _tds = new URANIE::DataServer::TDataServer();
    _tds->fileDataRead("basic.dat");
}
void TUncertModelerTest::tearDown()
{
    delete _tks;
    _tks = NULL;
    delete _tds;
    _tds = NULL;
}
void TUncertModelerTest::throwExceptionTUncertModelerConstructorTdsNull()
{
    TString svar = "w";
    URANIE::DataServer::TDataServer *tdsnull =
            new URANIE::DataServer::TDataServer();

    CPPUNIT_ASSERT_THROW(
            new URANIE::UncertModeler::TUncertModeler(tdsnull, "toto", "w"),
            URANIE::Exceptions::UWarningExceptions);

    delete tdsnull;
}
void TUncertModelerTest::testTUncertModelerConstructor()
{
    TString svar = "w";
    CPPUNIT_ASSERT_NO_THROW(
            _tks = new URANIE::UncertModeler::TUncertModeler(_tds, "essai",
                    "w"));
    _tks->unsetLog();
    _tks->printLog();
}
