//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.1 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TFakeEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-12-20.09.56.59

 \brief declaration de prototype
 */

#ifndef __TFAKEEVAL__
#define __TFAKEEVAL__

//ROOT
#include "Rtypes.h"

//URANIE
#include "Relauncher.h"
#include "TStandardEval.h"

namespace URANIE
{
namespace Relauncher
{

/* class TFakeMulti: public TSimpleMulti */
/* { */
/* public: */
/*     Int_t meval(double *, double **); */

/*     ClassDef(URANIE::Relauncher::TFakeMulti, ID_RELAUNCHER) */
/* }; */

class TFakeEval: public TSimpleEval
{
public:
    TFakeEval();

    Int_t eval(vector<URANIE::DataServer::UEntry*> *, vector<URANIE::DataServer::UEntry*> *, int =0 );

    ClassDef(URANIE::Relauncher::TFakeEval, ID_RELAUNCHER)
};


}
} //namespace

#endif

