//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TGradientEstimationRun.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-07-16.15.55.35

 \brief run modifier with finite differencies gradient estimation
 */

#ifndef __GRADIENT_ESTIMATION_RUN__
#define __GRADIENT_ESTIMATION_RUN__

#include <map>

//ROOT
#include "Rtypes.h"

// Uranie
#include "TShareRun.h"

namespace URANIE
{
namespace Relauncher
{

class TGradientEstimationRun: public TDecoratorRun
{
protected:

public:
    TGradientEstimationRun(TRun *run);
    virtual ~TGradientEstimationRun(void);

    virtual void put(long, std::vector<URANIE::DataServer::UEntry*>*, 
        std::vector<URANIE::DataServer::UEntry*>*, int =0);
    virtual Bool_t readyToGet();
    virtual int get(long &);

    ClassDef(URANIE::Relauncher::TGradientEstimationRun, ID_RELAUNCHER)
};

}
} //namespace

#endif
