//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TLauncher2.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2011-09-07.15.13.33

 \brief execution dun plan dexperience
 */

#ifndef _TLAUNCHER2__
#define _TLAUNCHER2__

//ROOT
#include "Rtypes.h"
#include "TNamed.h"

// Uranie
#include "Relauncher.h"
#include "TInformMaster.h"

#include "TDataServer.h"
#include "TEval.h"
#include "TDSNtupleD.h"

namespace URANIE
{
namespace Relauncher
{

class TLauncher2: public TNamed, public TInformMaster
{
protected:
    URANIE::DataServer::TDataServer *_tdserr;
    
public:
    TLauncher2(URANIE::DataServer::TDataServer *tds, TRun *run); 
    TLauncher2(URANIE::DataServer::TDataServer *tds, TEval *fun);
    TLauncher2(URANIE::DataServer::TDataServer *tds, TStandardEval *fun, const char *in, const char *out);
    virtual ~TLauncher2();

    void setSaveError(URANIE::DataServer::TDataServer *);
    
    virtual void solverLoop();

    ClassDef(URANIE::Relauncher::TLauncher2, ID_RELAUNCHER)

};

}
} //namespace
#endif
