//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TLineScript.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2011-09-19.15.00.57

 \brief entree sur une ligne
 */

#ifndef __TLINESCRIPT__
#define __TLINESCRIPT__

#include <fstream>
//ROOT
#include "TString.h"
#include "TObjArray.h"

//URANIE
#include "Relauncher.h"
#include "TAttribute.h"
#include "TFlatScript.h"

namespace URANIE
{
namespace Relauncher
{

class TLineScript: public TVoidScript
{
public:
    TLineScript(const char *path);
    virtual ~TLineScript();

    virtual void put(TString &ref, TString &tmp, Double_t *in);
    virtual void put(TString &ref, TString &tmp, vector<URANIE::DataServer::UEntry*> *in);

    ClassDef(URANIE::Relauncher::TLineScript, ID_RELAUNCHER)
};

}
} //namespace

#endif
