//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.4 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TSequentialRun.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2009-04-01.13.25.29

 \brief   main_loop de resolution
 */

#ifndef __RUN__
#define __RUN__

#include "TShareRun.h"

namespace URANIE
{
namespace Relauncher
{

class TSequentialRun: public TSimpleRun
{
protected:
    TEval *_workfun;

public:
    TSequentialRun(TEval *);
    virtual ~TSequentialRun(void);

    virtual void startSlave(void);
    virtual void stopSlave(void);

    virtual int get(long &);

    ClassDef(URANIE::Relauncher::TSequentialRun, ID_RELAUNCHER)
};

}
}
#endif

