//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TShareEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2011-12-13.12.25.42

 \brief implementation partage au TEval
 */

#ifndef __TShareEval__
#define __TShareEval__

//ROOT
#include "Rtypes.h"
#include "TObjArray.h"

// Uranie
#include "Relauncher.h"
#include "TEval.h"
#include "TBaseEval.h"
#include "TDataServer.h"

namespace URANIE
{
namespace Relauncher
{


class TShareEval: public TBaseEval
{
public:
    TShareEval() : TBaseEval() {}
    virtual void provideSingleResult()
    {
    }
    ;
    virtual int eval(std::vector<URANIE::DataServer::UEntry*>*, std::vector<URANIE::DataServer::UEntry*>*, int =0 ) { return 0; }
    
    ClassDef(URANIE::Relauncher::TShareEval, ID_RELAUNCHER)
};



}
} // namespace
#endif
