/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2021 CEA/DEN
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   TSubMpiRun.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2021-06-02
 
 \brief  runner mpi de deuxième niveau
*/

#ifndef __SUBMPIRUN__
#define __SUBMPIRUN__

#include "TMpiRun.h"

#include "TEval.h"

namespace URANIE
{
namespace MpiRelauncher
{

class TSubMpiRun : public TMpiRun
{
protected:
    int _sz, _id;
    
public:
    class NotInABiMPiRunContext {};
    
    TSubMpiRun(URANIE::Relauncher::TEval *r);
    virtual ~TSubMpiRun();
    
    ClassDef(URANIE::MpiRelauncher::TSubMpiRun, ID_RELAUNCHER)
};

}} //namespace

#endif
