//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestMain.cxx
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   jeu jan 24 15:56:01 2008
 
 $Revision$
 $Date$
 
 \brief Programme principal pour les tests unitaires sur la librairie Relauncher.
 
 */

// Liste des Tests Unitaires d'uranie
#include "TestTLauncher2.h"
#include "uranie_commands.h"

CPPUNIT_TEST_SUITE_REGISTRATION (TLauncher2Test);

bool uranie_test_suite(const char *module, const char *xml, const char *xsl);

int main()
{
    bool wasSuccessful;
#ifdef WIN32
    wasSuccessful = uranie_test_suite("Relauncher",
            "testRelauncherResults.xml", "..\\..\\..\\testReport.xsl");
#else
    wasSuccessful = uranie_test_suite("Relauncher",
            "testRelauncherResults.xml", "../../../testReport.xsl");
#endif

    ////////////////
    // Clean
    ////////////////

    UranieTests::removeFile(gSystem->pwd(), "_output_*.root");
    UranieTests::removeFile(gSystem->pwd(), "_output_*.dat");
#ifndef WIN32
    UranieTests::removeFolder(gSystem->pwd(),"URA_*");
#endif

    UranieTests::removeFolder(gSystem->pwd(),"tmpLanceurUranie");
    UranieTests::removeFolder(gSystem->pwd(),"URANIE");
    gDirectory->ls();

    // ---  Return error code 1 if the one of test failed.
    return wasSuccessful ? 0 : 1;
}
