//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2024 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestUserFunctions.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   2012-09-14 10:45:11

 \brief Inteface for the rosenbrock function
 */
#include "TEval.h"
int precodeComposeScalaire(Double_t *in, Double_t *out);
int postcodeComposeScalaire(Double_t *in, Double_t *out);
int precodeComposeMulti(Double_t *in, Double_t *out);
int postcodeComposeMulti(Double_t *in, Double_t *out);
int postcodeComposeMulti_hard(vector<URANIE::DataServer::UEntry*> *in, vector<URANIE::DataServer::UEntry*> *out);
void Ishigami(Double_t *paramt, Double_t *res);
int Ishigami2(Double_t *paramt, Double_t *res, void *plus);
int Ishigami3(Double_t *paramt, Double_t *res);
int FlowrateReatmt_hard(vector<URANIE::DataServer::UEntry*> *in, vector<URANIE::DataServer::UEntry*> *out);
int FakeGrad(Double_t *paramt, Double_t *res, Double_t *grad);

// End Of File
