#!/usr/bin/env python
# --- coding: utf-8 ---

import math

chu = 1050
chl = 770
cr  = 1100

Rw = 0.0500
R = 33366.67
Tu = 63070.0
Tl = 116.00
Hu = 1110.00
Hl = 768.57
L = 1200.0
Kw = 11732.14

def waterborehole(drw, dr, dtu, dtl, dhu, dhl, dl, dkw) :
    dnum = 2.0 * math.pi * dtu * ( dhu -dhl);
    dlnronrw = math.log( dr / drw);
    dden = dlnronrw * ( 1.0 +  ( 2.0 * dl * dtu ) / ( dlnronrw * drw * drw * dkw) + dtu / dtl );
    return dnum / dden;

def distance(dhu, dhl) :
    tmp = (dhu - chu)
    tmp2 = (dhl - chl)
    return tmp*tmp + tmp2*tmp2

def echo(drw, dr, dtu, dtl, dhu, dhl, dl, dkw) :
    print "# en tete"
    print 
    print "ŷ", waterborehole(drw, dr, dtu, dtl, dhu, dhl, dl, dkw)
    print "dist", distance(Hu, Hl)

echo(Rw, R, Tu, Tl, Hu, Hl, L, Kw)

