void createUranieUVersionFile()
{
  // Reads from the file version_number the new uranie version number
   // and generates the header ../UranieVersion.h.
   // To be executed as CINT script by build/unix/makeversion.sh.
   //
   // Author: Fons Rademakers   11/10/99

  const char *incvs  = "adm/version_number";
  const char *outh = "dataSERVER/souRCE/UVersion.h";

  cout << endl;
  cout << " ** Read the uranie version from file[" << incvs<<"]"<<endl;
  cout << " ** and create the header file[" << outh <<"]"<<endl;


  // The local time
  time_t theNow;
  time(&theNow);
  tm *ff = localtime(&theNow);
  printf(" ** Local Time : %s\n", asctime(ff));

  char bufferdate [80];
  char buffertime [80];
  strftime (bufferdate,80,"%a %b %d, %Y",ff);
  strftime (buffertime,80,"%H:%M:%S",ff);
 
  //////////////////////////////////
  //// Open the input : version number
  //////////////////////////////////
  FILE *fp = fopen(incvs, "r");
  if (!fp) {
    printf("can not open input file %s\n", incvs);
    exit(1);
  }
  char vers[32];
  fgets(vers, sizeof(vers), fp);
  if (vers[strlen(vers)-1] == '\n') vers[strlen(vers)-1] = 0;
  fclose(fp);
  cout << " ** Original version in the input file[" <<vers<<"]"<<endl;
   
  int ncharvers = strlen(vers);
  
  
  int xx = 0, yy = 0, zz = 0;
  
  if ( ncharvers == 9 ) {
    xx = 1900 + ff->tm_year;
    yy = 1 + ff->tm_mon;
    zz = 1 + ff->tm_mday;
  } else {
    sscanf(vers, "$Name: v%d_%d_%d ", &xx, &yy, &zz);
  }
  
  cout << " ** final Version "<< xx<<"."<<yy<<"/"<<zz<<endl<<endl;
  
  int vers_code = (xx << 16) + (yy << 8) + zz;
  
  //////////////////////////////////
  //// Create the output : header file
  //////////////////////////////////
  ofstream file_stream(outh);
  if (file_stream.bad()) {
    cerr << "can not open output file " << outh << endl;
    exit(1);
  }

  file_stream << "#ifndef URANIE_UVersion\n";
  file_stream << "#define URANIE_UVersion\n\n";
  file_stream << "/* Version information automatically generated by installer. */\n\n";
  file_stream << "/*\n";
  file_stream << " * These macros can be used in the following way:\n";
  file_stream << " *\n";
  file_stream << " *    #if URANIE_VERSION_CODE >= URANIE_VERSION(0,4,1)\n";
  file_stream << " *       #include <newheader.h>\n";
  file_stream << " *    #else\n";
  file_stream << " *       #include <oldheader.h>\n";
  file_stream << " *    #endif\n";
  file_stream << " *\n";
  file_stream << "*/\n\n";
  file_stream << "#define URANIE_RELEASE \"" << xx << "." << yy << "/" << zz << "\"\n";
  file_stream << "#define URANIE_RELEASE_MAJOR " << xx << "\n";
  file_stream << "#define URANIE_RELEASE_MINOR " << yy << "\n";
  file_stream << "#define URANIE_RELEASE_PATCH " << zz << "\n";
  file_stream << "#define URANIE_RELEASE_DATE \"" << bufferdate << "\"\n";
  file_stream << "#define URANIE_RELEASE_TIME \"" << buffertime << "\"\n";
  file_stream << "#define URANIE_VERSION_CODE " << vers_code << "\n";
  file_stream << "#define URANIE_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))\n";
  file_stream << "\n#endif\n";
}
